/*************************************************************************
 *
 *  $RCSfile: XclImpChartsApi.cxx,v $
 *
 *  $Revision: 1.13 $
 *
 *  last change: $Author: dr $ $Date: 2001/07/18 12:12:36 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
#include "filt_pch.hxx"
#endif

#pragma hdrstop

//------------------------------------------------------------------------

#ifndef _SC_XCLIMPCHARTS_HXX
#include "XclImpCharts.hxx"
#endif

// awt
#ifndef _COM_SUN_STAR_AWT_FONTSLANT_HPP_
#include <com/sun/star/awt/FontSlant.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_FONTUNDERLINE_HPP_
#include <com/sun/star/awt/FontUnderline.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_GRADIENT_HPP_
#include <com/sun/star/awt/Gradient.hpp>
#endif

// beans
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSET_HPP_
#include <com/sun/star/beans/XPropertySet.hpp>
#endif

// chart
#ifndef _COM_SUN_STAR_CHART_CHARTAXISASSIGN_HPP_
#include <com/sun/star/chart/ChartAxisAssign.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_CHARTAXISMARKS_HPP_
#include <com/sun/star/chart/ChartAxisMarks.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_CHARTDATACAPTION_HPP_
#include <com/sun/star/chart/ChartDataCaption.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_CHARTDATAROWSOURCE_HPP_
#include <com/sun/star/chart/ChartDataRowSource.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_CHARTLEGENDPOSITION_HPP_
#include <com/sun/star/chart/ChartLegendPosition.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_CHARTSOLIDTYPE_HPP_
#include <com/sun/star/chart/ChartSolidType.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_CHARTSYMBOLTYPE_HPP_
#include <com/sun/star/chart/ChartSymbolType.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_X3DDISPLAY_HPP_
#include <com/sun/star/chart/X3DDisplay.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_XAXISXSUPPLIER_HPP_
#include <com/sun/star/chart/XAxisXSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_XAXISZSUPPLIER_HPP_
#include <com/sun/star/chart/XAxisZSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_XCHARTDOCUMENT_HPP_
#include <com/sun/star/chart/XChartDocument.hpp>
#endif
#ifndef __com_sun_star_chart_XStatisticDisplay_HPP__
#include <com/sun/star/chart/XStatisticDisplay.hpp>
#endif
#ifndef _COM_SUN_STAR_CHART_XTWOAXISYSUPPLIER_HPP_
#include <com/sun/star/chart/XTwoAxisYSupplier.hpp>
#endif

// drawing
#ifndef _COM_SUN_STAR_DRAWING_FILLSTYLE_HPP_
#include <com/sun/star/drawing/FillStyle.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_LINEDASH_HPP_
#include <com/sun/star/drawing/LineDash.hpp>
#endif
#ifndef _COM_SUN_STAR_DRAWING_LINESTYLE_HPP_
#include <com/sun/star/drawing/LineStyle.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XSHAPE_HPP_
#include <com/sun/star/drawing/XShape.hpp>
#endif

// frame
#ifndef _COM_SUN_STAR_FRAME_XMODEL_HPP_
#include <com/sun/star/frame/XModel.hpp>
#endif

// lang
#ifndef _COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HPP_
#include <com/sun/star/lang/XMultiServiceFactory.hpp>
#endif

// util
#ifndef _COM_SUN_STAR_UTIL_DATE_HPP_
#include <com/sun/star/util/Date.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_XNUMBERFORMATSSUPPLIER_HPP_
#include <com/sun/star/util/XNumberFormatsSupplier.hpp>
#endif

#ifndef _ZFORMAT_HXX
#include <svtools/zformat.hxx>
#endif
#ifndef _SVX_COLRITEM_HXX
#include <svx/colritem.hxx>
#endif
#ifndef _TOOLKIT_HELPER_VCLUNOHELPER_HXX_
#include <toolkit/unohlp.hxx>
#endif

#ifndef _XCEPTION_HXX_ //autogen wg. TRY
#include <vos/xception.hxx>
#endif
#ifndef _VOS_NO_NAMESPACE
using namespace vos;
#endif

#ifndef SC_DOCUMENT_HXX
#include "document.hxx"
#endif
#ifndef _FLTTOOLS_HXX
#include "flttools.hxx"
#endif
#ifndef _SC_XCLIMPHELPER_HXX
#include "XclImpHelper.hxx"
#endif

using namespace ::rtl;
using namespace ::com::sun::star;


//___________________________________________________________________

#define SC_STDCHARTCOLORS	56

static BYTE aStdFillColor[SC_STDCHARTCOLORS] =
{ 16, 17, 18, 19, 20, 21, 22, 23,				// zuerst die Flaechenfarben
  24, 25, 26, 27, 28, 29, 30, 31,				// dann die Linienfarben
  32, 33, 34, 35, 36, 37, 38, 39,				// den Rest einfach durchgezaehlt
  40, 41, 42, 43, 44, 45, 46, 47,
  48, 49, 50, 51, 52, 53, 54, 55,
   0,  1,  2,  3,  4,  5,  6,  7,
   8,  9, 10, 11, 12, 13, 14, 15 };

static BYTE aStdLineColor[SC_STDCHARTCOLORS] =
{ 24, 25, 26, 27, 28, 29, 30, 31,				// zuerst die Linienfarben
  32, 33, 34, 35, 36, 37, 38, 39,				// dann die "sonstigen" Farben
  40, 41, 42, 43, 44, 45, 46, 47,
  48, 49, 50, 51, 52, 53, 54,					// 55 taucht nicht auf
   0,  1,  2,  3,  4,  5,  6,  7,
   8,  9, 10, 11, 12, 13, 14, 15,
  16, 17, 18, 19, 20, 21, 22, 23,				// zuletzt die Flaechenfarben
  55 };											// (Excel schraffiert die 56. schon)



void lcl_SetPropVal( const uno::Reference< beans::XPropertySet >& xProp, const OUString& rName, const uno::Any& rAny )
{
	TRY
	{
		xProp->setPropertyValue( rName, rAny );
	}
	CATCH_ALL()
	{
	}
	END_CATCH;
}


void lcl_SetPropString( const uno::Reference< beans::XPropertySet >& xProp, const OUString& rName, const String& rText )
{
	OUString sOUText( rText );
	TRY
	{
		xProp->setPropertyValue( rName, uno::Any( &sOUText, getCppuType( &sOUText ) ) );
	}
	CATCH_ALL()
	{
	}
	END_CATCH;
}


void lcl_SetPropBool( const uno::Reference< beans::XPropertySet >& xProp, const OUString& rName, sal_Bool bValue )
{
	TRY
	{
		uno::Reference< beans::XPropertySetInfo > xInfo = xProp->getPropertySetInfo();
		if( xInfo.is() && xInfo->hasPropertyByName( rName ) )
			xProp->setPropertyValue( rName, uno::Any( &bValue, getBooleanCppuType() ) );
	}
	CATCH_ALL()
	{
	}
	END_CATCH;
}


template< class T > void lcl_SetPropVal( const uno::Reference< beans::XPropertySet >& xProp, const OUString& rName, T value )
{
	TRY
	{
		uno::Reference< beans::XPropertySetInfo > xInfo = xProp->getPropertySetInfo();
		if( xInfo.is() && xInfo->hasPropertyByName( rName ) )
			xProp->setPropertyValue( rName, uno::Any( &value, getCppuType( &value ) ) );
	}
	CATCH_ALL()
	{
	}
	END_CATCH;
}


//___________________________________________________________________
// FRAME group

sal_Int32 lcl_LineWidth( INT16 nExcelWeight )
{
	switch( nExcelWeight )
	{
		case EXC_CHART_LINEF_SINGLE:	return 35;
		case EXC_CHART_LINEF_DOUBLE:	return 70;
		case EXC_CHART_LINEF_TRIPLE:	return 105;
	}
	return 0;
}

void lcl_LineStyle(
        sal_uInt16 nPattern, sal_Int32 nWidth, drawing::LineStyle& rStyle,
        sal_Int16& rTrans, drawing::LineDash& rDash )
{
	rTrans = 0;
	rDash.Style = drawing::DashStyle_RECT;
	rDash.Dots = 0;
	rDash.Dashes = 0;
	rDash.Distance = rDash.DotLen = Min( (sal_Int32)(nWidth + 105), (sal_Int32)210 );
	rDash.DashLen = rDash.DotLen * 4;

	switch( nPattern )
	{
		case EXC_CHART_LINEF_SOLID:
			rStyle = drawing::LineStyle_SOLID;
		break;
		case EXC_CHART_LINEF_DARKTRANS:
			rStyle = drawing::LineStyle_SOLID;
			rTrans = 25;
		break;
		case EXC_CHART_LINEF_MEDTRANS:
			rStyle = drawing::LineStyle_SOLID;
			rTrans = 50;
		break;
		case EXC_CHART_LINEF_LIGHTTRANS:
			rStyle = drawing::LineStyle_SOLID;
			rTrans = 75;
		break;
		case EXC_CHART_LINEF_DASH:
			rStyle = drawing::LineStyle_DASH;
			rDash.Dashes = 1;
		break;
		case EXC_CHART_LINEF_DOT:
			rStyle = drawing::LineStyle_DASH;
			rDash.Dots = 1;
		break;
		case EXC_CHART_LINEF_DASHDOT:
			rStyle = drawing::LineStyle_DASH;
			rDash.Dashes = rDash.Dots = 1;
		break;
		case EXC_CHART_LINEF_DASHDOTDOT:
			rStyle = drawing::LineStyle_DASH;
			rDash.Dashes = 1;
			rDash.Dots = 2;
		break;
		default:
			rStyle = drawing::LineStyle_NONE;
	}
}

void lcl_SetLineFormat(
        const uno::Reference< beans::XPropertySet >& xProp,
        sal_Int32 nWidth, UINT16 nPattern, sal_Int32 nColor )
{
	if( !xProp.is() ) return;

	drawing::LineStyle	eStyle;
	sal_Int16			nTrans;
	drawing::LineDash	aDash;
	lcl_LineStyle( nPattern, nWidth, eStyle, nTrans, aDash );

	lcl_SetPropVal( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_LINESTYLE ) ), eStyle );
	lcl_SetPropVal( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_LINEWIDTH ) ), nWidth );
	lcl_SetPropVal( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_LINECOLOR ) ), nColor );
	lcl_SetPropVal( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_LINETRANSPARENCE ) ), nTrans );
	if( eStyle == drawing::LineStyle_DASH )
	{
		uno::Any aAny;
		aAny <<= aDash;
		lcl_SetPropVal( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_LINEDASH ) ), aAny );
	}
}

BOOL lcl_SetLineFormat(
        const uno::Reference< beans::XPropertySet >& xProp,
        const ExcChart_Lineformat* pLineFormat )
{
	if( !pLineFormat || pLineFormat->bAuto ) return FALSE;

	lcl_SetLineFormat( xProp, lcl_LineWidth( pLineFormat->nWeight ),
		pLineFormat->nPattern, pLineFormat->nLineColor );
	return TRUE;
}

void lcl_SetStandardLine(
		const uno::Reference< beans::XPropertySet >& xProp,
		UINT32 nRowNum,
		ColorBuffer* pColorBuf,
		ExcChartType eChartType,
		BOOL bIs3D )
{
	//	Excel standard colors (keep line style)
	if( !xProp.is() ) return;

	nRowNum %= SC_STDCHARTCOLORS;
	sal_Int32 nColor = 0x00000000;
	UINT16 nPattern = EXC_CHART_LINEF_SOLID;
	if( pColorBuf && ((eChartType == ctLine) || (eChartType == ctStock) || (eChartType == ctScatter) || (eChartType == ctNet)) )
	{
		USHORT nIndex = aStdLineColor[ nRowNum ];
		if ( nIndex < ColorBuffer::GetAnz() )
		{
			const SvxColorItem* pItem = pColorBuf->GetColor( nIndex + ColorBuffer::GetIndCorrect() );
			if( pItem )
				nColor = pItem->GetValue().GetColor();
		}
	}
    else if( bIs3D && ((eChartType == ctArea) || (eChartType == ctBar) ||
                        (eChartType == ctColumn) || (eChartType == ctPie) || (eChartType == ctUnknown)) )
		nPattern = EXC_CHART_LINEF_NONE;

	lcl_SetLineFormat( xProp, 0, nPattern, nColor );
}

void lcl_SetAreaFormat(
        const uno::Reference< beans::XPropertySet >& xProp,
        drawing::FillStyle eStyle, sal_Int32 nColor )
{
	if( !xProp.is() ) return;
	lcl_SetPropVal( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_FILLSTYLE ) ), eStyle );
	lcl_SetPropVal( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_FILLCOLOR ) ), nColor );
}

void lcl_SetAreaFormat( const uno::Reference< beans::XPropertySet >& xProp, const awt::Gradient& rGradient )
{
	if( !xProp.is() ) return;

	uno::Any aAny;
	aAny <<= rGradient;
	lcl_SetPropVal( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_FILLSTYLE ) ), drawing::FillStyle_GRADIENT );
	lcl_SetPropVal( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_FILLGRADIENT ) ), aAny );
	lcl_SetPropVal( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_FILLGRADIENTSTEPC ) ), rGradient.StepCount );
}

BOOL lcl_SetAreaFormat(
        const uno::Reference< beans::XPropertySet >& xProp,
        const ExcChart_Areaformat* pAreaFormat )
{
	if( !pAreaFormat || pAreaFormat->bAuto ) return FALSE;

	if( pAreaFormat->pFillData && pAreaFormat->pFillData->IsValid() )
	{
		awt::Gradient aGradient;
		aGradient.Style = pAreaFormat->pFillData->eStyle;
		aGradient.StartColor = (sal_Int32) pAreaFormat->pFillData->nForeColor;
		aGradient.EndColor = (sal_Int32) pAreaFormat->pFillData->nBackColor;
		aGradient.Angle = pAreaFormat->pFillData->nAngle;
		aGradient.Border = 0;
		aGradient.XOffset = pAreaFormat->pFillData->nXOffset;
		aGradient.YOffset = pAreaFormat->pFillData->nYOffset;
		aGradient.StartIntensity = 100;
		aGradient.EndIntensity = 100;
		aGradient.StepCount = 256;
		lcl_SetAreaFormat( xProp, aGradient );
	}
	else
	{
		drawing::FillStyle	eStyle		= drawing::FillStyle_NONE;
		ColorData			nFillColor	= COL_BLACK;

		if ( pAreaFormat->nPattern != EXC_CHART_AREAF_NONE )
		{
			eStyle = drawing::FillStyle_SOLID;
			if ( pAreaFormat->nPattern == EXC_CHART_AREAF_SOLID )
				nFillColor = pAreaFormat->nForeColor;
			else
				//!	create Svx-Pattern, if !=SOLID
				nFillColor = pAreaFormat->nBackColor;
		}
		lcl_SetAreaFormat( xProp, eStyle, nFillColor );
	}
	return TRUE;
}

void lcl_SetStandardFill( const uno::Reference< beans::XPropertySet >& xProp, UINT32 nRowNum, ColorBuffer* pColorBuf )
{
	//	Excel standard colors (solid style)
	if( nRowNum < SC_STDCHARTCOLORS && xProp.is() && pColorBuf )
	{
		USHORT nIndex = aStdFillColor[nRowNum];
		if( nIndex < ColorBuffer::GetAnz() )
		{
			const SvxColorItem* pItem = pColorBuf->GetColor( nIndex + ColorBuffer::GetIndCorrect() );
			if( pItem )
				lcl_SetAreaFormat( xProp, drawing::FillStyle_SOLID, (sal_Int32) pItem->GetValue().GetColor() );
		}
	}
}

void lcl_SetFrameFormat(
        const uno::Reference< beans::XPropertySet >& xProp,
        const ExcChart_Lineformat* pLine, const ExcChart_Areaformat* pArea )
{
	lcl_SetLineFormat( xProp, pLine );
	lcl_SetAreaFormat( xProp, pArea );
}


//___________________________________________________________________
// shape position

void lcl_SetPosition(
        const uno::Reference< drawing::XShape >& xShape, const ExcChart_Pos& rPos,
        UINT16 nRot, const Size& rRealSize, BOOL bSetSize )
{
	if( !xShape.is() ) return;

	awt::Point	aPoint(	(rPos.nPosX * rRealSize.Width()) / 4000, (rPos.nPosY * rRealSize.Height()) / 4000 );
	awt::Size	aSize( (rPos.nWidth * rRealSize.Width()) / 4000, (rPos.nHeight * rRealSize.Height()) / 4000 );

	if( !bSetSize )
	{
		aPoint.X = Max( aPoint.X, (long) SC_CHART_MINDIST );
		aPoint.Y = Max( aPoint.Y, (long) SC_CHART_MINDIST );

		sal_Int32 nScRot = XclImpHelper::GetRotation( nRot );
		if( (nScRot > 13500) && (nScRot < 31500) )
			aPoint.X += aSize.Width;
		if( (nScRot > 4500) && (nScRot < 22500) )
			aPoint.Y += aSize.Height;

		aPoint.X = Min( aPoint.X, (long)(rRealSize.Width() - aSize.Width - SC_CHART_MINDIST) );
		aPoint.Y = Min( aPoint.Y, (long)(rRealSize.Height() - aSize.Height - SC_CHART_MINDIST) );
	}

	TRY
	{
		xShape->setPosition( aPoint );
		if( bSetSize )
			xShape->setSize( aSize );
	}
	CATCH_ALL()
	{
	}
	END_CATCH
}


//___________________________________________________________________
// TEXT group

void lcl_SetCharHeight( const uno::Reference< beans::XPropertySet >& xProp, float fPoints )
{
	if( !xProp.is() ) return;
	lcl_SetPropVal( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_CHARHEIGHT ) ), fPoints );
}

void lcl_FontAttribs( const uno::Reference< beans::XPropertySet >& xProp, const ScExcFont* pExcFont )
{
	if( !xProp.is() ) return;
	if( pExcFont )
	{
        const SvxFontItem& rFontItem = ((ScExcFont*)pExcFont)->GetFontItem();
        const SvxFontHeightItem& rHeightItem = ((ScExcFont*)pExcFont)->GetHeightItem();

        FontWeight eFontWeight;
        USHORT nWeight = pExcFont->nWeight;
        if( !nWeight )                                  eFontWeight = WEIGHT_DONTKNOW;
        else if( nWeight <= EXC_FONTWGHT_THIN )         eFontWeight = WEIGHT_THIN;
        else if( nWeight <= EXC_FONTWGHT_ULTRALIGHT )   eFontWeight = WEIGHT_ULTRALIGHT;
        else if( nWeight <= EXC_FONTWGHT_LIGHT )        eFontWeight = WEIGHT_LIGHT;
        else if( nWeight <= EXC_FONTWGHT_SEMILIGHT )    eFontWeight = WEIGHT_SEMILIGHT;
        else if( nWeight <= EXC_FONTWGHT_NORMAL )       eFontWeight = WEIGHT_NORMAL;
        else if( nWeight <= EXC_FONTWGHT_MEDIUM )       eFontWeight = WEIGHT_MEDIUM;
        else if( nWeight <= EXC_FONTWGHT_SEMIBOLD )     eFontWeight = WEIGHT_SEMIBOLD;
        else if( nWeight <= EXC_FONTWGHT_BOLD )         eFontWeight = WEIGHT_BOLD;
        else if( nWeight <= EXC_FONTWGHT_ULTRABOLD )    eFontWeight = WEIGHT_ULTRABOLD;
        else                                            eFontWeight = WEIGHT_BLACK;

        short nNewUnderline = awt::FontUnderline::NONE;
        switch ( pExcFont->eUnderline )
        {
            case ExcUndNone:        nNewUnderline = awt::FontUnderline::NONE;   break;
            case ExcUndSingleAcc:
            case ExcUndSingle:      nNewUnderline = awt::FontUnderline::SINGLE; break;
            case ExcUndDoubleAcc:
            case ExcUndDouble:      nNewUnderline = awt::FontUnderline::DOUBLE; break;
        }

        // font name
        lcl_SetPropString( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_CHARFONTNAME ) ), rFontItem.GetFamilyName() );
        // font weight to enum to float
        lcl_SetPropVal( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_CHARWEIGHT ) ), VCLUnoHelper::ConvertFontWeight( eFontWeight ) );
        // font underline
        lcl_SetPropVal( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_CHARUNDERL ) ), (sal_Int16) nNewUnderline );
        // font height
        lcl_SetCharHeight( xProp, (float)(rHeightItem.GetHeight() / EXC_FONTHGHT_COEFF) );
        // italic
        awt::FontSlant eSlant = pExcFont->bItalic ? awt::FontSlant_ITALIC : awt::FontSlant_NONE;
        lcl_SetPropVal( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_CHARPOSTURE ) ), eSlant );
        // shadow
        lcl_SetPropBool( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_CHARSHADOWED ) ), pExcFont->bShadow );
        // outline
        lcl_SetPropBool( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_CHARCONTOURED ) ), pExcFont->bOutline );
        // strikeout
        lcl_SetPropBool( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_CHARCROSSEDOUT ) ), pExcFont->bStrikeout );
	}
	else
		lcl_SetCharHeight( xProp, 10.0 );
}

void lcl_SetRotation( const uno::Reference< beans::XPropertySet >& xProp, UINT16 nRot )
{
	lcl_SetPropVal( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_TEXTROTATION ) ), XclImpHelper::GetRotation( nRot ) );
}

void lcl_SetTextData(
        const uno::Reference< beans::XPropertySet >& xTextProp,
        const ExcChart_Text* pTextData, const ExcChart_Text* pDefText )
{
    const ExcChart_Text* pText = pTextData ? pTextData : pDefText;
	if( !xTextProp.is() ) return;
	if( pText )
	{
		if ( !pText->bAutoColor )
			lcl_SetPropVal( xTextProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_CHARCOLOR ) ), (sal_Int32) pText->nTextColor );
		lcl_FontAttribs( xTextProp, pText->pFont );
		lcl_SetRotation( xTextProp, pText->nRot );
		lcl_SetFrameFormat( xTextProp, pText->pLine, pText->pArea );
	}
	else
		lcl_SetCharHeight( xTextProp, 10.0 );
}

void lcl_SetTextData(
        const uno::Reference< drawing::XShape >& xTextShape,
        const ExcChart_Text* pTextData, const ExcChart_Text* pDefText, const Size& rRealSize )
{
    const ExcChart_Text* pText = pTextData ? pTextData : pDefText;
	if( !xTextShape.is() || !pText ) return;

	uno::Reference< beans::XPropertySet > xTextProp( xTextShape, uno::UNO_QUERY );
	if( xTextProp.is() && pText->pString )
		lcl_SetPropString( xTextProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_STRING ) ), *pText->pString );
	lcl_SetTextData( xTextProp, pText, NULL );
	lcl_SetPosition( xTextShape, pText->aPos, pText->nRot, rRealSize, FALSE );
}


//___________________________________________________________________
// AXIS group

void lcl_AxisValueFormat(
        const uno::Reference< beans::XPropertySet >& xAxis,
        const ExcChart_ValueRange* pValRange, BOOL bManualOrigin )
{
	if( !pValRange ) return;

	if( !(bManualOrigin && pValRange->bAutoCross && pValRange->bAutoMin && pValRange->bAutoMax) )
	{
		//	Bei Bar-Charts (bManualOrigin) Origin nicht auf automatisch stellen,
		//	bis die automatische Skalierung der von Excel aehnlicher wird.
		//	Bei manueller Skalierung muss aber auch der Origin uebernommen werden,
		//	damit die Skalierung ueberhaupt wirkt.

		lcl_SetPropBool( xAxis, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_AUTOORIG ) ), pValRange->bAutoCross );
		if( !pValRange->bAutoCross )
			lcl_SetPropVal( xAxis, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_ORIGIN ) ), pValRange->fCross );
	}

	lcl_SetPropBool( xAxis, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_AUTOMIN ) ), pValRange->bAutoMin );
	if( !pValRange->bAutoMin )
		lcl_SetPropVal( xAxis, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_MIN ) ), pValRange->fMin );

	lcl_SetPropBool( xAxis, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_AUTOMAX ) ), pValRange->bAutoMax );
	if( !pValRange->bAutoMax )
		lcl_SetPropVal( xAxis, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_MAX ) ), pValRange->fMax );

	lcl_SetPropBool( xAxis, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_AUTOSTMAIN ) ), pValRange->bAutoMajor );
	if( !pValRange->bAutoMajor )
		lcl_SetPropVal( xAxis, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_STEPMAIN ) ), pValRange->fMajorInc );

	lcl_SetPropBool( xAxis, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_AUTOSTHELP ) ), pValRange->bAutoMinor );
	if( !pValRange->bAutoMinor )
		lcl_SetPropVal( xAxis, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_STEPHELP ) ), pValRange->fMinorInc );

	//!	gibt Probleme:
	lcl_SetPropBool( xAxis, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_LOG ) ), pValRange->bLogScale );
}

sal_Int32 lcl_TickPosToAxisMarks( UINT8 nTick )
{
	sal_Int32 nRet = chart::ChartAxisMarks::NONE;
	if( nTick & EXC_CHART_TICK_INSIDE )
		nRet |= chart::ChartAxisMarks::INNER;
	if( nTick & EXC_CHART_TICK_OUTSIDE )
		nRet |= chart::ChartAxisMarks::OUTER;
	return nRet;
}

void lcl_AxisTickFormat( const uno::Reference< beans::XPropertySet >& xAxis, const ExcChart_Tick* pTick )
{
	if( !pTick ) return;

	if( !pTick->bAutoColor )
		lcl_SetPropVal( xAxis, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_CHARCOLOR ) ), (sal_Int32) pTick->nTextColor );
	lcl_SetPropVal( xAxis, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_MARKS ) ), lcl_TickPosToAxisMarks( pTick->nMajor ) );
	lcl_SetPropVal( xAxis, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HELPMARKS ) ), lcl_TickPosToAxisMarks( pTick->nMinor ) );
}

sal_Bool lcl_HasDescription( const ExcChart_Axis& rAxis )
{
    return
        (rAxis.pTick ? (rAxis.pTick->nLabel != EXC_CHART_TICK_NOLABEL) : sal_True) &&
        (rAxis.pAxisLine ? rAxis.pAxisLine->bDrawTick : sal_True);
}


//___________________________________________________________________
// DATAFORMAT group

void lcl_SetDataCaption(
        const uno::Reference< beans::XPropertySet >& xProp, const UINT16* pFlags,
        const ExcChart_Text* pTextData, const ExcChart_Text* pDefText0,
        const ExcChart_Text* pDefText1 )
{
	UINT16	nFlags		= pFlags ? *pFlags : 0x0000;
	BOOL	bLabel		= TRUEBOOL( nFlags & (EXC_CHART_ATLAB_SHOWLABEL | EXC_CHART_ATLAB_SHOWLABELPERC) );
	BOOL	bValue		= TRUEBOOL( nFlags & EXC_CHART_ATLAB_SHOWVALUE );
	BOOL	bPercent	= TRUEBOOL( nFlags & (EXC_CHART_ATLAB_SHOWPERCENT | EXC_CHART_ATLAB_SHOWLABELPERC) );

	sal_Int32 nCaption = 0x00000000;

	if( bValue )
		nCaption |= chart::ChartDataCaption::VALUE;
	if( bPercent )
		nCaption |= chart::ChartDataCaption::PERCENT;
	if( bLabel )
		nCaption |= chart::ChartDataCaption::TEXT;
	if( pTextData && pTextData->bShowKey )
		nCaption |= chart::ChartDataCaption::SYMBOL;

	lcl_SetPropVal( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_DATACAPTION ) ), nCaption );
	lcl_SetTextData( xProp, pTextData, bLabel ? pDefText0 : pDefText1 );
}

BOOL lcl_SetMarkerFormat(
        const uno::Reference< beans::XPropertySet >& xProp,
        const ExcChart_MarkerFormat* pMForm )
{
	if( !pMForm ) return FALSE;

	Color aForeColor( pMForm->nForeColor );
	Color aBackColor( pMForm->nBackColor );
	sal_Int32 nSymbolType;
	switch ( pMForm->nMarkerType )
	{
		case 0:		nSymbolType = chart::ChartSymbolType::NONE;		break;
		case 1:		nSymbolType = chart::ChartSymbolType::SYMBOL0;	break;
		case 2:		nSymbolType = chart::ChartSymbolType::SYMBOL1;	break;
		case 3:		nSymbolType = chart::ChartSymbolType::SYMBOL3;	break;
		case 4:		nSymbolType = chart::ChartSymbolType::SYMBOL2;	break;
		case 5:		nSymbolType = chart::ChartSymbolType::SYMBOL4;	break;
		case 6:		nSymbolType = chart::ChartSymbolType::AUTO;		break;
		case 7:		nSymbolType = chart::ChartSymbolType::SYMBOL5;	break;
		case 8:		nSymbolType = chart::ChartSymbolType::SYMBOL6;	break;
		case 9:		nSymbolType = chart::ChartSymbolType::SYMBOL7;	break;
		default:	nSymbolType = chart::ChartSymbolType::SYMBOL1;
	}
	lcl_SetPropVal( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_SYMBOLTYPE ) ), nSymbolType );
	return TRUE;
}

void lcl_SetStandardMarker(
        const uno::Reference< beans::XPropertySet >& xProp,
        UINT32 nRowNum, ColorBuffer* pColorBuf )
{
//	if ( nRowNum < SC_STDCHARTCOLORS && xProp.is() && pColorBuf )
//	{
//	}
}

void lcl_SetPieDistance( const uno::Reference< beans::XPropertySet >& xProp, const UINT16* pDist )
{
	if( !pDist ) return;
	sal_Int32 nDist = (sal_Int32) Min( (UINT16)100, *pDist );
	lcl_SetPropVal( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_SEGMENTOFFSET ) ), nDist );
}

void lcl_Set3DDataFormat(
        const uno::Reference< beans::XPropertySet >& xProp,
        const ExcChart_3DDataFormat* pFormat )
{
	if( !pFormat ) return;

	sal_Int32 nType;
	if( pFormat->nBase == EXC_CHART_DATAF_RECT )
		nType = (pFormat->nTop == EXC_CHART_DATAF_STRAIGHT) ?
			chart::ChartSolidType::RECTANGULAR_SOLID : chart::ChartSolidType::PYRAMID;
	else
		nType = (pFormat->nTop == EXC_CHART_DATAF_STRAIGHT) ?
			chart::ChartSolidType::CYLINDER : chart::ChartSolidType::CONE;

	lcl_SetPropVal( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_SOLIDTYPE ) ), nType );
}


//___________________________________________________________________
// diagram area position/size

// #88701# re-enabled for all chart types with axes
//void lcl_SetDiagramPosition( const uno::Reference< chart::XDiagram >& xDiagram,
//                          ExcChart_AxesSet* pPrimAS, const Size& rRealSize,
//                          ExcChartType eChartType, UINT16 nMaxPieDist )
void lcl_SetDiagramPosition(
        const uno::Reference< chart::XDiagram >& xDiagram,
        const ExcChart_AxesSet* pPrimAS, const ExcChart_AxesSet* pSecAS,
        const Size& rRealSize, ExcChartType eChartType )
{
    if( !pPrimAS ) return;

    ExcChart_Pos aPos( pPrimAS->aPos );

    // add title size and axis caption size
    if( (eChartType != ctPie) && (eChartType != ctDonut) && (eChartType != ctNet) )
    {
        if( pPrimAS->pCatAxis )
        {
            ExcChart_Axis& rAxis = *pPrimAS->pCatAxis;
            long nTitleW = rAxis.pTitle ? rAxis.pTitle->aPos.nWidth : 0;
            long nTitleH = rAxis.pTitle ? rAxis.pTitle->aPos.nHeight : 0;
            long nXDescr = lcl_HasDescription( rAxis ) ? 120 : 0;
            if( eChartType == ctBar )
            {
                aPos.nPosX -= nTitleW + nXDescr;
                aPos.nWidth += nTitleW + nXDescr;
            }
            else
                aPos.nHeight += nTitleH + nXDescr;
        }

        if( pPrimAS->pValueAxis )
        {
            ExcChart_Axis& rAxis = *pPrimAS->pValueAxis;
            long nTitleW = rAxis.pTitle ? rAxis.pTitle->aPos.nWidth : 0;
            long nTitleH = rAxis.pTitle ? rAxis.pTitle->aPos.nHeight : 0;
            long nYDescr = lcl_HasDescription( *pPrimAS->pValueAxis ) ? 120 : 0;
            long nYDescr2 = (pSecAS && pSecAS->pValueAxis && lcl_HasDescription( *pSecAS->pValueAxis )) ? 120 : 0;
            if( eChartType == ctBar )
            {
                aPos.nPosY -= nYDescr2;
                aPos.nHeight += nTitleH + nYDescr + nYDescr2;
            }
            else
            {
                aPos.nPosX -= nTitleW + nYDescr;
                aPos.nWidth += nTitleW + nYDescr + nYDescr2;
            }
        }
    }

//    // enlarge area of pie charts
//    nMaxPieDist = Min( nMaxPieDist, (UINT16)100 );
//    if( nMaxPieDist )
//    {
//        double fScale = (double) nMaxPieDist / 100.0;
//        UINT32 nAdd = (UINT32)((double) aPos.nWidth * fScale);
//        aPos.nPosX -= (nAdd >> 1);
//        aPos.nWidth += nAdd;
//        nAdd = (UINT32)((double) aPos.nHeight * fScale);
//        aPos.nPosY -= (nAdd >> 1);
//        aPos.nHeight += nAdd;
//    }

    uno::Reference< drawing::XShape > xDiaShape( xDiagram, uno::UNO_QUERY );
    if( xDiaShape.is() )
        lcl_SetPosition( xDiaShape, aPos, 0, rRealSize, TRUE );
}


//___________________________________________________________________
// apply chart

void ExcChart::SetDataRowProperties( uno::Reference< chart::XDiagram > xDiagram ) const
{
	//!	die Abfrage kann raus, wenn getDataRow/getDataPoint
	//!	bei ungueltigen Werten NULL zurueckgibt

	if ( !xDiagram.is() || !pSourceData || !pSeries ) return;

	//	umschliessenden Range zusammensuchen
	ScRange aSourceRange;
	ScRangeListRef xRanges = pSourceData->GetRangeList();
	if ( xRanges.Is() && xRanges->Count() )
	{
		aSourceRange = *xRanges->GetObject( 0 );
		ULONG nCount = xRanges->Count();
		for( ULONG i = 1; i < nCount; i++ )
		{
			ScRange aRange = *xRanges->GetObject(i);
			if (aRange.aStart.Tab() == aSourceRange.aStart.Tab())
			{
				if (aRange.aStart.Col() < aSourceRange.aStart.Col())
					aSourceRange.aStart.SetCol(aRange.aStart.Col());
				if (aRange.aStart.Row() < aSourceRange.aStart.Row())
					aSourceRange.aStart.SetRow(aRange.aStart.Row());
				if (aRange.aEnd.Col() > aSourceRange.aEnd.Col())
					aSourceRange.aEnd.SetCol(aRange.aEnd.Col());
				if (aRange.aEnd.Row() > aSourceRange.aEnd.Row())
					aSourceRange.aEnd.SetRow(aRange.aEnd.Row());
			}
		}
	}
	USHORT nSourceColCount = aSourceRange.aEnd.Col() - aSourceRange.aStart.Col() + 1;
	USHORT nSourceRowCount = aSourceRange.aEnd.Row() - aSourceRange.aStart.Row() + 1;
	if( pSourceData->GetDir() )
	{
		USHORT nTemp = nSourceColCount;
		nSourceColCount = nSourceRowCount;
		nSourceRowCount = nTemp;
	}
	if( bHasSeriesNames )
		--nSourceColCount;					// ColCount = count of points per series
	if( bHasCategoryNames )
		--nSourceRowCount;					// RowCount = count of series (data rows)

	BOOL bPie = (eChartType == ctPie);
	BOOL bDonut = (eChartType == ctDonut);

	const ExcChart_Point* pGlobal = pSeries->GetGlobalFormatPtr();
	for( UINT32 nSerNum = 0; (nSerNum + nRowOffset) < nSourceRowCount; nSerNum++ )
	{
		const ExcChart_Series*	pSer = pSeries->FindBySerNum( nSerNum );
		ExcChart_Point*			pRow = pSer ? pSer->pAll : NULL;

		if( pRow )
		{
			if( pGlobal )
				pRow->Update( *pGlobal );
			// attributes of data rows
			TRY
			{
				sal_Int32 nCount = (bPie || bDonut) ? nSourceColCount : 1;
				for( sal_Int32 nPoint = 0; nPoint < nCount; nPoint++ )
				{
					uno::Reference< beans::XPropertySet > xDataRow;
					if( bDonut )
						xDataRow = xDiagram->getDataPointProperties( nSerNum + nRowOffset, nPoint );
					else if( bPie )
						xDataRow = xDiagram->getDataPointProperties( nPoint, nSerNum + nRowOffset );
					else
						xDataRow = xDiagram->getDataRowProperties( nSerNum + nRowOffset );

					if( xDataRow.is() )
					{
						if( !lcl_SetLineFormat( xDataRow, pRow->pLine ) )
							lcl_SetStandardLine( xDataRow, nSerNum, pExcRoot->pColor, eChartType, p3D != NULL );
						if( !lcl_SetAreaFormat( xDataRow, pRow->pArea ) )
							lcl_SetStandardFill( xDataRow, (bPie || bDonut) ? nPoint : nSerNum, pExcRoot->pColor );
						if( !lcl_SetMarkerFormat( xDataRow, pRow->pMarker ) )
							lcl_SetStandardMarker( xDataRow, nSerNum, pExcRoot->pColor );
						lcl_Set3DDataFormat( xDataRow, pRow->p3DData );
						lcl_SetDataCaption( xDataRow, pRow->pLabel, pRow->pText, pDefText0, pDefText1 );
						lcl_SetPieDistance( xDataRow, pRow->pPieDist );
					}
				}
			}
			CATCH_ALL()
			{
			}
			END_CATCH;
		}

		// attributes of single data points
		ExcChart_PointList* pDataPoints = pSer ? pSer->pSpec : NULL;
		if( pDataPoints )
		{
			for( const ExcChart_Point* pPoint = pDataPoints->First(); pPoint; pPoint = pDataPoints->Next() )
			{
				UINT32 nColNum = pPoint->nPointNum;
				if( nColNum < nSourceColCount )
				{
					TRY
					{
						uno::Reference< beans::XPropertySet > xDataPoint = bDonut ?
							xDiagram->getDataPointProperties( nSerNum + nRowOffset, nColNum ) :
							xDiagram->getDataPointProperties( nColNum, nSerNum + nRowOffset );
						if( xDataPoint.is() )
						{
							lcl_SetFrameFormat( xDataPoint, pPoint->pLine, pPoint->pArea );
							lcl_SetMarkerFormat( xDataPoint, pPoint->pMarker );
							lcl_Set3DDataFormat( xDataPoint, pPoint->p3DData );
							lcl_SetDataCaption( xDataPoint, pPoint->pLabel, pPoint->pText, pDefText0, pDefText1 );
							lcl_SetPieDistance( xDataPoint, pPoint->pPieDist );
						}
					}
					CATCH_ALL()
					{
					}
					END_CATCH;
				}
			}
		}
	}
}

void ExcChart::Apply( uno::Reference< lang::XComponent > xComponent, const Rectangle& rAnchor ) const
{
	if( !xComponent.is() ) return;

	Size aRealSize = rAnchor.GetSize();
	uno::Reference< frame::XModel > xModel( xComponent, uno::UNO_QUERY );

	xModel->lockControllers();		// don't redraw
	ApplyExt( xComponent );			// before getDiagram

	uno::Reference< chart::XChartDocument >	xChartDoc( xComponent, uno::UNO_QUERY );
	uno::Reference< beans::XPropertySet >	xDocProp( xChartDoc, uno::UNO_QUERY );
	if( !xModel.is() || !xChartDoc.is() || !xDocProp.is() ) return;

	uno::Reference< chart::XDiagram > xDiagram = xChartDoc->getDiagram();
	if( !xDiagram.is() ) return;

	uno::Reference< chart::XAxisXSupplier >	 	xDiaXSup( xDiagram, uno::UNO_QUERY );
	uno::Reference< chart::XTwoAxisYSupplier >	xDiaYSup( xDiagram, uno::UNO_QUERY );
	uno::Reference< chart::XAxisZSupplier >		xDiaZSup( xDiagram, uno::UNO_QUERY );
	uno::Reference< chart::X3DDisplay >			xDiagr3D( xDiagram, uno::UNO_QUERY );
	uno::Reference< beans::XPropertySet >		xDiaProp( xDiagram, uno::UNO_QUERY );
	if( !xDiaXSup.is() || !xDiaYSup.is() || !xDiaZSup.is() || !xDiagr3D.is() || !xDiaProp.is() )
		return;

	// *** GENERAL SETTINGS ***

	if( pSourceData )
	{
		chart::ChartDataRowSource eSource = pSourceData->GetDir() ?
			chart::ChartDataRowSource_COLUMNS : chart::ChartDataRowSource_ROWS;
		lcl_SetPropVal( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_ROWSOURCE ) ), eSource );
	}

	if( bSpline )
		lcl_SetPropVal( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_SPLINETYPE ) ), (sal_Int32)1 );
	lcl_SetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_DIM3D ) ), (p3D != NULL) );
	if( p3D )
		lcl_SetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_DEEP ) ), !p3D->bCluster );
	lcl_SetPropVal( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_SYMBOLTYPE ) ), chart::ChartSymbolType::AUTO );

	lcl_SetFrameFormat( xChartDoc->getArea(), pLine, pArea );

	// *** Y AXIS ***

	if( pPrimAS && pPrimAS->pValueAxis )
	{
		ExcChart_Axis& rAxis = *pPrimAS->pValueAxis;

		if( p3D )
			lcl_SetFrameFormat( xDiagr3D->getFloor(), rAxis.pWallLine, rAxis.pWallArea );

		lcl_SetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASYAXIS ) ), sal_True );
		sal_Bool bHasDescr = lcl_HasDescription( rAxis );
		lcl_SetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASYAXISDESCR ) ), bHasDescr );

		lcl_SetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASYAXISGRID ) ), (rAxis.pMajorLine != NULL) );
		lcl_SetLineFormat( xDiaYSup->getYMainGrid(), rAxis.pMajorLine );
		lcl_SetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASYAXISHELPGRID ) ), (rAxis.pMinorLine != NULL) );
		lcl_SetLineFormat( xDiaYSup->getYHelpGrid(), rAxis.pMinorLine );

		uno::Reference< beans::XPropertySet > xYAxis = xDiaYSup->getYAxis();
		if( xYAxis.is() )
		{
			if( rAxis.nNumForm != EXC_CHART_IFMT_INVALID )
            {
                lcl_SetPropBool( xYAxis, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_LINKNUMFMT ) ), sal_False );
				lcl_SetPropVal( xYAxis, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_NUMFMT ) ), rAxis.nNumForm );
            }

			//	bei Saeulen/Balkendiagrammen kommt unser Chart nicht gut mit automatischem
			//	Origin zurecht -> dann nur hart gesetzte Werte uebernehmen
            BOOL bManualOrigin = (eChartType == ctBar) || (eChartType == ctColumn) || (eChartType == ctUnknown);
			lcl_AxisValueFormat( xYAxis, rAxis.pValueRange, bManualOrigin );
			lcl_SetLineFormat( xYAxis, rAxis.pAxisLine );
			lcl_AxisTickFormat( xYAxis, rAxis.pTick );
			lcl_SetPropBool( xYAxis, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_TEXTOVERLAP ) ), sal_False );
			lcl_SetPropBool( xYAxis, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_TEXTBREAK ) ), rAxis.bBreakText );
			if( bHasDescr )
				lcl_SetTextData( xYAxis, rAxis.pCaptionText, pDefText2 );
		}

		lcl_SetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASYAXISTIT ) ), (rAxis.pTitle != NULL) );
		if( rAxis.pTitle )
		{
			xModel->unlockControllers();	// create object
			lcl_SetTextData( xDiaYSup->getYAxisTitle(), rAxis.pTitle, pDefText2, aRealSize );
			xModel->lockControllers();
		}
	}
	else
	{
		lcl_SetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASYAXIS ) ), sal_False );
		lcl_SetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASYAXISDESCR ) ), sal_False );
	}

	// *** SECONDARY Y AXIS ***

	if( bSecondary && pSeries )
	{
  		for( const ExcChart_Series*	pSer = pSeries->First(); pSer; pSer = pSeries->Next() )
		{
			if( pSer->bSecondary )
			{
				TRY
				{
					uno::Reference< beans::XPropertySet > xDataRow =
						xDiagram->getDataRowProperties( pSer->nSerInd + nRowOffset );
					if( xDataRow.is() )
						lcl_SetPropVal( xDataRow, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_AXIS ) ),
							chart::ChartAxisAssign::SECONDARY_Y );
				}
				CATCH_ALL()
				{
				}
				END_CATCH;
			}
		}

		if( pSecAS && pSecAS->pValueAxis )
		{
			ExcChart_Axis& rAxis = *pSecAS->pValueAxis;

			lcl_SetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASSECYAXIS ) ), sal_True );
			sal_Bool bHasDescr = lcl_HasDescription( rAxis );
			lcl_SetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASSECYAXISDESCR ) ), bHasDescr );

			uno::Reference< beans::XPropertySet > xYAxis = xDiaYSup->getSecondaryYAxis();
			if( xYAxis.is() )
			{
				if( rAxis.nNumForm != EXC_CHART_IFMT_INVALID )
                {
                    lcl_SetPropBool( xYAxis, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_LINKNUMFMT ) ), sal_False );
					lcl_SetPropVal( xYAxis, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_NUMFMT ) ), rAxis.nNumForm );
                }

				//	bei Saeulen/Balkendiagrammen kommt unser Chart nicht gut mit automatischem
				//	Origin zurecht -> dann nur hart gesetzte Werte uebernehmen
                BOOL bManualOrigin = (eChartType == ctBar) || (eChartType == ctColumn) || (eChartType == ctUnknown);
				lcl_AxisValueFormat( xYAxis, rAxis.pValueRange, bManualOrigin );
				lcl_SetLineFormat( xYAxis, rAxis.pAxisLine );
				lcl_AxisTickFormat( xYAxis, rAxis.pTick );
				lcl_SetPropBool( xYAxis, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_TEXTOVERLAP ) ), sal_False );
				lcl_SetPropBool( xYAxis, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_TEXTBREAK ) ), rAxis.bBreakText );
				if( bHasDescr )
					lcl_SetTextData( xYAxis, rAxis.pCaptionText, pDefText2 );
			}
		}
		else
		{
			lcl_SetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASSECYAXIS ) ), sal_False );
			lcl_SetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASSECYAXISDESCR ) ), sal_False );
		}
	}

	// *** X AXIS ***

	if( pPrimAS && pPrimAS->pCatAxis )
	{
		ExcChart_Axis& rAxis = *pPrimAS->pCatAxis;

		lcl_SetLineFormat( xDiagr3D->getWall(), p3D ? rAxis.pWallLine : pPlotLine );
		lcl_SetAreaFormat( xDiagr3D->getWall(), p3D ? rAxis.pWallArea : pPlotArea );

		lcl_SetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASXAXIS ) ), sal_True );
		sal_Bool bHasDescr = lcl_HasDescription( rAxis );
		lcl_SetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASXAXISDESCR ) ), bHasDescr );

		lcl_SetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASXAXISGRID ) ), (rAxis.pMajorLine != NULL) );
		lcl_SetLineFormat( xDiaXSup->getXMainGrid(), rAxis.pMajorLine );
		lcl_SetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASXAXISHELPGRID ) ), (rAxis.pMinorLine != NULL) );
		lcl_SetLineFormat( xDiaXSup->getXHelpGrid(), rAxis.pMinorLine );

		uno::Reference< beans::XPropertySet > xXAxis = xDiaXSup->getXAxis();
		if( xXAxis.is() )
		{
			// value range / number format for XY charts
			if( rAxis.nNumForm != EXC_CHART_IFMT_INVALID )
            {
                lcl_SetPropBool( xXAxis, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_LINKNUMFMT ) ), sal_False );
				lcl_SetPropVal( xXAxis, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_NUMFMT ) ), rAxis.nNumForm );
            }

			lcl_AxisValueFormat( xXAxis, rAxis.pValueRange, FALSE );
			lcl_SetLineFormat( xXAxis, rAxis.pAxisLine );
			lcl_AxisTickFormat( xXAxis, rAxis.pTick );
			lcl_SetPropBool( xXAxis, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_TEXTOVERLAP ) ), sal_False );
			lcl_SetPropBool( xXAxis, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_TEXTBREAK ) ), rAxis.bBreakText );
			if( bHasDescr )
				lcl_SetTextData( xXAxis, rAxis.pCaptionText, pDefText2 );
		}

		lcl_SetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASXAXISTIT ) ), (rAxis.pTitle != NULL) );
		if( rAxis.pTitle )
		{
			xModel->unlockControllers();	// create object
			lcl_SetTextData( xDiaXSup->getXAxisTitle(), rAxis.pTitle, pDefText2, aRealSize );
			xModel->lockControllers();
		}
	}
	else
	{
		lcl_SetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASXAXIS ) ), sal_False );
		lcl_SetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASXAXISDESCR ) ), sal_False );
	}

	// *** Z AXIS ***

	if( pPrimAS && pPrimAS->pSeriesAxis )
	{
		ExcChart_Axis& rAxis = *pPrimAS->pSeriesAxis;

		lcl_SetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASZAXIS ) ), sal_True );
		sal_Bool bHasDescr = lcl_HasDescription( rAxis );
		lcl_SetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASZAXISDESCR ) ), bHasDescr );

		lcl_SetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASZAXISGRID ) ), (rAxis.pMajorLine != NULL) );
		lcl_SetLineFormat( xDiaZSup->getZMainGrid(), rAxis.pMajorLine );
		lcl_SetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASZAXISHELPGRID ) ), (rAxis.pMinorLine != NULL) );
		lcl_SetLineFormat( xDiaZSup->getZHelpGrid(), rAxis.pMinorLine );

		uno::Reference< beans::XPropertySet > xZAxis = xDiaZSup->getZAxis();
		if( xZAxis.is() )
		{
			lcl_SetPropBool( xZAxis, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_TEXTOVERLAP ) ), sal_False );
			lcl_SetPropBool( xZAxis, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_TEXTBREAK ) ), rAxis.bBreakText );
			lcl_SetLineFormat( xZAxis, rAxis.pAxisLine );
			lcl_AxisTickFormat( xZAxis, rAxis.pTick );
			if( bHasDescr )
				lcl_SetTextData( xZAxis, rAxis.pCaptionText, pDefText2 );
		}

		lcl_SetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASZAXISTIT ) ), (rAxis.pTitle != NULL) );
		if( rAxis.pTitle )
		{
			xModel->unlockControllers();	// Objekt wirklich anlegen
			lcl_SetTextData( xDiaZSup->getZAxisTitle(), rAxis.pTitle, pDefText2, aRealSize );
			xModel->lockControllers();
		}
	}
	else
	{
		lcl_SetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASZAXIS ) ), sal_False );
		lcl_SetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASZAXISDESCR ) ), sal_False );
	}

	// *** DATA ROW / POINT PROPERTIES ***

	SetDataRowProperties( xDiagram );

	Date* pDate = pExcRoot->pDoc->GetFormatTable()->GetNullDate();
	if( pDate )
	{
		uno::Reference< util::XNumberFormatsSupplier > xNumFormSup( xDiaXSup->getXAxis(), uno::UNO_QUERY );
		if( xNumFormSup.is() )
		{
			util::Date aDate( pDate->GetDay(), pDate->GetMonth(), pDate->GetYear() );
			uno::Reference< beans::XPropertySet > xProp = xNumFormSup->getNumberFormatSettings();
			lcl_SetPropVal( xProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_NULLDATE ) ), aDate );
		}
	}

	ApplyExtPost( xComponent );

	// *** CHART TITLE ***

	lcl_SetPropBool( xDocProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASMAINTIT ) ), (pChartTitle != NULL) );
	if( pChartTitle )
	{
		xModel->unlockControllers();
		lcl_SetTextData( xChartDoc->getTitle(), pChartTitle, pDefText2, aRealSize );
		xModel->lockControllers();
	}

	// *** DIAGRAM POSITION ***

	// #86197# and several other problems with diagram positioning -> disabled
//	lcl_SetDiagramPosition( xDiagram, pPrimAS, aRealSize, eChartType, (eChartType == ctPie) ? nMaxPieDist : 0 );

    // #88701# re-enabled for all chart types with axes
    if( (eChartType != ctPie) && (eChartType != ctDonut) && (eChartType != ctNet) )
//        lcl_SetDiagramPosition( xDiagram, pPrimAS, aRealSize, eChartType, 0 );
        lcl_SetDiagramPosition( xDiagram, pPrimAS, pSecAS, aRealSize, eChartType );

	// *** LEGEND ***

	lcl_SetPropBool( xDocProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_HASLEGEND ) ), (pLegend != NULL) );
	if( pLegend )
	{
		uno::Reference< drawing::XShape > xLegendShape = xChartDoc->getLegend();
		uno::Reference< beans::XPropertySet > xLegendProp( xLegendShape, uno::UNO_QUERY );
		if( xLegendShape.is() && xLegendProp.is() )
		{
			lcl_SetFrameFormat( xLegendProp, pLegend->pLine, pLegend->pArea );
			lcl_SetTextData( xLegendProp, pLegend->pText, pDefText2 );

            chart::ChartLegendPosition eLegendPos = chart::ChartLegendPosition_RIGHT;
			switch ( pLegend->nType )
			{
                case EXC_CHART_LEGEND_BOTTOM:   eLegendPos = chart::ChartLegendPosition_BOTTOM; break;
                case EXC_CHART_LEGEND_TOP:      eLegendPos = chart::ChartLegendPosition_TOP;    break;
                case EXC_CHART_LEGEND_RIGHT:    eLegendPos = chart::ChartLegendPosition_RIGHT;  break;
                case EXC_CHART_LEGEND_LEFT:     eLegendPos = chart::ChartLegendPosition_LEFT;   break;
			}

            lcl_SetPropVal( xLegendProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_ALIGNMENT ) ), eLegendPos );
			lcl_SetPosition( xLegendShape, pLegend->aPos, 0, aRealSize, FALSE );

            // #88701# correct diagram area
            xModel->unlockControllers();
            xModel->lockControllers();
            uno::Reference< drawing::XShape > xDiaShape( xDiagram, uno::UNO_QUERY );
            if( xDiaShape.is() && pPrimAS )
            {
                awt::Point aAwtPt = xLegendShape->getPosition();
                awt::Size aAwtSz = xLegendShape->getSize();
                Point aLegTL( aAwtPt.X, aAwtPt.Y );
                Point aLegBR( aAwtPt.X + aAwtSz.Width, aAwtPt.Y + aAwtSz.Height );

                aAwtPt = xDiaShape->getPosition();
                aAwtSz = xDiaShape->getSize();
                Point aDiaTL( aAwtPt.X, aAwtPt.Y );
                Point aDiaBR( aAwtPt.X + aAwtSz.Width, aAwtPt.Y + aAwtSz.Height );

                const ExcChart_Pos& rXlDia = pPrimAS->aPos;
                const ExcChart_Pos& rXlLeg = pLegend->aPos;

                if( (aDiaTL.Y() <= aLegBR.Y()) && (aDiaBR.Y() >= aLegTL.Y()) )
                {
                    long nDist = aLegTL.X() - aDiaBR.X();
                    if( (nDist < 0) && (rXlLeg.nPosX >= (long)(rXlDia.nPosX + rXlDia.nWidth)) )
                        aAwtSz.Width += nDist - SC_CHART_MINDIST;
                    else
                    {
                        nDist = aDiaTL.X() - aLegBR.X();
                        if( (nDist < 0) && (rXlDia.nPosX >= (long)(rXlLeg.nPosX + rXlLeg.nWidth)) )
                        {
                            aAwtPt.X -= nDist - SC_CHART_MINDIST;
                            aAwtSz.Width += nDist - SC_CHART_MINDIST;
                        }
                    }
                }
                else if( (aDiaTL.X() <= aLegBR.X()) && (aDiaBR.X() >= aLegTL.X()) )
                {
                    long nDist = aLegTL.Y() - aDiaBR.Y();
                    if( (nDist < 0) && (rXlLeg.nPosY >= (long)(rXlDia.nPosY + rXlDia.nHeight)) )
                        aAwtSz.Height += nDist - SC_CHART_MINDIST;
                    else
                    {
                        nDist = aDiaTL.Y() - aLegBR.Y();
                        if( (nDist < 0) && (rXlDia.nPosY >= (long)(rXlLeg.nPosY + rXlLeg.nHeight)) )
                        {
                            aAwtPt.Y -= nDist - SC_CHART_MINDIST;
                            aAwtSz.Height += nDist - SC_CHART_MINDIST;
                        }
                    }
                }

                TRY
                {
                    xDiaShape->setPosition( aAwtPt );
                    xDiaShape->setSize( aAwtSz );
                }
                CATCH_ALL()
                {
                }
                END_CATCH
            }
        }
	}

	xModel->unlockControllers();
}

//___________________________________________________________________
// chart types

void lcl_SetChartType( uno::Reference< lang::XComponent > xComponent, const OUString& rType )
{
	uno::Reference< chart::XChartDocument > xChartDoc( xComponent, uno::UNO_QUERY );
	uno::Reference< lang::XMultiServiceFactory > xFactory( xComponent, uno::UNO_QUERY );
	if( !xChartDoc.is() || !xFactory.is() ) return;
	uno::Reference< uno::XInterface > xInstance = xFactory->createInstance( rType );
	uno::Reference< chart::XDiagram > xNewDiagram( xInstance, uno::UNO_QUERY );
	if( !xNewDiagram.is() ) return;
	xChartDoc->setDiagram( xNewDiagram );
}


void ExcChartLine::ApplyExt( uno::Reference< lang::XComponent > xComponent ) const
{
	if( !xComponent.is() ) return;

	if( eChartType == ctArea )
		lcl_SetChartType( xComponent, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_STRING_AREA ) ) );
	else if( bStock )
		lcl_SetChartType( xComponent, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_STRING_STOCK ) ) );
	else
		lcl_SetChartType( xComponent, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_STRING_LINE ) ) );	// vor getDiagram

	uno::Reference< chart::XChartDocument > xChartDoc( xComponent, uno::UNO_QUERY );
	if( !xChartDoc.is() ) return;
	uno::Reference< chart::XDiagram > xDiagram = xChartDoc->getDiagram();
	uno::Reference< beans::XPropertySet > xDiaProp( xDiagram, uno::UNO_QUERY );
	if( !xDiagram.is() || !xDiaProp.is() ) return;

	// #86200# setting "Percent" to sal_False resets "Stacked" even if it was set
	if( bStacked )
		lcl_SetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_STACKED ) ), sal_True );
	if( bCatAsPercent )
		lcl_SetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_PERCENT ) ), sal_True );
}

void ExcChartLine::ApplyExtPost( uno::Reference< lang::XComponent > xComponent ) const
{
	if( !xComponent.is() || (eChartType == ctArea) ) return;

	uno::Reference< chart::XChartDocument > xChartDoc( xComponent, uno::UNO_QUERY );
	if( !xChartDoc.is() ) return;
	uno::Reference< chart::XDiagram > xDiagram = xChartDoc->getDiagram();
	uno::Reference< beans::XPropertySet > xDiaProp( xDiagram, uno::UNO_QUERY );
	if( !xDiagram.is() || !xDiaProp.is() ) return;

	if( bStock )
	{
		lcl_SetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_UPDOWN ) ), (pUpBar || pDownBar) );
		lcl_SetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_VOLUME ) ), bSecondary );

		uno::Reference< chart::XStatisticDisplay > xStat( xDiagram, uno::UNO_QUERY );
		if( xStat.is() )
		{
			lcl_SetLineFormat( xStat->getMinMaxLine(), pHiLoLine );
			if( pUpBar )
				lcl_SetFrameFormat( xStat->getUpBar(), pUpBar->pLine, pUpBar->pArea );
			if( pDownBar )
				lcl_SetFrameFormat( xStat->getDownBar(), pDownBar->pLine, pDownBar->pArea );
		}
	}
	else
	{
		lcl_SetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_STACKED ) ), bStacked );
		lcl_SetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_PERCENT ) ), bCatAsPercent );
	}
}


void ExcChartBar::ApplyExt( uno::Reference< lang::XComponent > xComponent ) const
{
	if( !xComponent.is() ) return;
	lcl_SetChartType( xComponent, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_STRING_BAR ) ) );	// vor getDiagram

	uno::Reference< chart::XChartDocument > xChartDoc( xComponent, uno::UNO_QUERY );
	if( !xChartDoc.is() ) return;
	uno::Reference< chart::XDiagram > xDiagram = xChartDoc->getDiagram();
	uno::Reference< chart::XTwoAxisYSupplier > xDiaYSup( xDiagram, uno::UNO_QUERY );
	uno::Reference< beans::XPropertySet > xDiaProp( xDiagram, uno::UNO_QUERY );
	if( !xDiagram.is() || !xDiaYSup.is() || !xDiaProp.is() ) return;

	lcl_SetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_VERTICAL ) ), bHorizontal );

	// #86200# setting "Percent" to sal_False resets "Stacked" even if it was set
	if( bStacked )
		lcl_SetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_STACKED ) ), sal_True );
	if( bCatAsPercent )
		lcl_SetPropBool( xDiaProp, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_PERCENT ) ), sal_True );

	//!	CHART_PROP_STACKCONN

	//	GapWidth / Overlap
	uno::Reference< beans::XPropertySet > xYAxis = xDiaYSup->getYAxis();
	if( xYAxis.is() )
	{
		lcl_SetPropVal( xYAxis, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_GAPWIDTH ) ), (sal_Int32) nSpaceBeetwCat );
		lcl_SetPropVal( xYAxis, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_OVERLAP ) ), (sal_Int32) nSpaceBeetwBar );
	}

	uno::Reference< beans::XPropertySet > xSecondary = xDiaYSup->getSecondaryYAxis();
	if( xSecondary.is() )
	{
		//	eigene Werte fuer 2. Y-Achse aus Excel lesen
		lcl_SetPropVal( xSecondary, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_GAPWIDTH ) ), (sal_Int32) nSpaceBeetwCat );
		lcl_SetPropVal( xSecondary, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_PROP_OVERLAP ) ), (sal_Int32) nSpaceBeetwBar );
	}
}


void ExcChartPie::ApplyExt( uno::Reference< lang::XComponent > xComponent ) const
{
	if( !xComponent.is() ) return;

	if( nHoleSize == 0 )
		lcl_SetChartType( xComponent, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_STRING_PIE ) ) );
	else
		lcl_SetChartType( xComponent, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_STRING_DONUT ) ) );
}


void ExcChartRadar::ApplyExt( uno::Reference< lang::XComponent > xComponent ) const
{
	if( !xComponent.is() ) return;
	lcl_SetChartType( xComponent, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_STRING_NET ) ) );	// vor getDiagram
}


void ExcChartSurface::ApplyExt( uno::Reference< lang::XComponent > ) const
{
	//	koenn' wa nich?
}

void ExcChartScatter::ApplyExt( uno::Reference< lang::XComponent > xComponent ) const
{
	if( !xComponent.is() ) return;
	lcl_SetChartType( xComponent, OUString( RTL_CONSTASCII_USTRINGPARAM( CHART_STRING_XY ) ) );	// vor getDiagram
}


