/*************************************************************************
 *
 *  $RCSfile: viewshel.cxx,v $
 *
 *  $Revision: 1.15 $
 *
 *  last change: $Author: ka $ $Date: 2001/07/30 15:56:36 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _COM_SUN_STAR_TASK_XSTATUSINDICATOR_HPP_ 
#include <com/sun/star/task/XStatusIndicator.hpp>
#endif
#ifndef _COM_SUN_STAR_DOCUMENT_XGRAPHICOBJECTRESOLVER_HPP 
#include <com/sun/star/document/XGraphicObjectResolver.hpp>
#endif
#ifndef _COMPHELPER_PROCESSFACTORY_HXX_
#include <comphelper/processfactory.hxx>
#endif
#ifndef _UTL_STREAM_WRAPPER_HXX_
#include <unotools/streamwrap.hxx>
#endif
#ifndef _XMLGRHLP_HXX
#include <svx/xmlgrhlp.hxx>
#endif
#ifndef _COM_SUN_STAR_XML_SAX_XDOCUMENTHANDLER_HPP_ 
#include <com/sun/star/xml/sax/XDocumentHandler.hpp>
#endif
#ifndef _COM_SUN_STAR_DOCUMENT_XFILTER_HPP_ 
#include <com/sun/star/document/XFilter.hpp>
#endif
#ifndef _COM_SUN_STAR_DOCUMENT_XIMPORTER_HPP_ 
#include <com/sun/star/document/XImporter.hpp>
#endif
#ifndef _COM_SUN_STAR_DOCUMENT_XGRAPHICOBJECTRESOLVER_HXX_
#include <com/sun/star/document/XGraphicObjectResolver.hpp>
#endif
#include <com/sun/star/xml/sax/XErrorHandler.hpp>
#include <com/sun/star/xml/sax/XEntityResolver.hpp>
#include <com/sun/star/xml/sax/InputSource.hpp>
#include <com/sun/star/xml/sax/XDTDHandler.hpp>
#include <com/sun/star/xml/sax/XParser.hpp>
#include <com/sun/star/io/XActiveDataSource.hpp>
#include <com/sun/star/io/XActiveDataControl.hpp>

#ifndef _COM_SUN_STAR_TASK_XINTERACTIONHANDLER_HPP_
#include <com/sun/star/task/XInteractionHandler.hpp>
#endif
#ifndef _COM_SUN_STAR_UCB_XPROGRESSHANDLER_HPP_
#include <com/sun/star/ucb/XProgressHandler.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_XARCHIVER_HPP_
#include <com/sun/star/util/XArchiver.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XINDEXACCESS_HPP_
#include <com/sun/star/container/XIndexAccess.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_PROPERTYVALUE_HPP_
#include <com/sun/star/beans/PropertyValue.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HPP_
#include <com/sun/star/lang/XMultiServiceFactory.hpp>
#endif
#ifndef _SFXITEMPOOL_HXX //autogen wg. SfxItemPool
#include <svtools/itempool.hxx>
#endif
#ifndef _SFXSTYLE_HXX //autogen wg. SfxStyleSheetPool
#include <svtools/style.hxx>
#endif
#ifndef _SOT_FORMATS_HXX //autogen wg. SOT_FORMATSTR_ID_STARIMPRESS_50
#include <sot/formats.hxx>
#endif
#ifndef _SOT_STORAGE_HXX //autogen wg. SotStorage
#include <sot/storage.hxx>
#endif
#ifndef _E3D_VIEW3D_HXX //autogen wg. E3dView
#include <svx/view3d.hxx>
#endif
#ifndef _B3D_BASE3D_HXX
#include "goodies/base3d.hxx"
#endif
#ifndef _SVT_FILEDLG_HXX //autogen wg. FileDialog
#include <svtools/filedlg.hxx>
#endif
#ifndef _SD_CUSSHOW_HXX
#include <sd/cusshow.hxx>
#endif
#ifndef _OSL_FILE_HXX_ 
#include <osl/file.hxx>
#endif
#ifndef _SV_MSGBOX_HXX
#include <vcl/msgbox.hxx>
#endif
#ifndef _URLOBJ_HXX
#include <tools/urlobj.hxx>
#endif
#ifndef _UNOTOOLS_TEMPFILE_HXX
#include <unotools/tempfile.hxx>
#endif
#ifndef _EHDL_HXX
#include <svtools/ehdl.hxx>
#endif
#ifndef _SFXECODE_HXX
#include <svtools/sfxecode.hxx>
#endif
#ifndef _SVDOUTL_HXX
#include <svx/svdoutl.hxx>
#endif
#include <svx/dialmgr.hxx>
#ifndef _UCBHELPER_CONTENT_HXX_
#include <ucbhelper/content.hxx>
#endif
#ifndef _UCBHELPER_CONTENTBROKER_HXX_
#include <ucbhelper/contentbroker.hxx>
#endif

#include <unotools/processfactory.hxx>
#include <unotools/localfilehelper.hxx>

#include "app.hxx"
#include <sd/app.hrc>
#include "strings.hrc"

#include "sip.hrc"
#include <sd/strmname.h>
#include "viewshel.hxx"
#include "sdresid.hxx"
#include <sd/drawdoc.hxx>
#include <sd/sdpage.hxx>
#include "progrdlg.hxx"
#include "centraldlg.hxx"
#include "appwin.hxx"
#include "view.hxx"
#include "passwd.hxx"
#include "fuslshow.hxx"

using namespace ::ucb;
using namespace ::rtl;
using namespace ::vos;
using namespace ::com::sun::star;
using namespace ::com::sun::star::ucb;

#define DELTA_ZOOM  10

extern uno::Reference< task::XInteractionHandler > InteractionHandler_createInstance();
extern uno::Reference< ::com::sun::star::ucb::XProgressHandler > ProgressHandler_createInstance( const Link& rLink );

// --------------------------------------------------------------------

#define POOL_BUFFER_SIZE		(sal_uInt16)32768
#define DOCUMENT_BUFFER_SIZE	(sal_uInt16)32768

#define XML_STRING(n,s) sal_Char __FAR_DATA n[sizeof(s)] = s

XML_STRING( sXML_metaStreamName, "meta.xml" );
XML_STRING( sXML_styleStreamName, "styles.xml" );
XML_STRING( sXML_contentStreamName, "content.xml" );
XML_STRING( sXML_oldContentStreamName, "Content.xml" );

XML_STRING( sXML_import_impress_service, "com.sun.star.comp.Impress.XMLImporter" );
XML_STRING( sXML_import_impress_meta_service, "com.sun.star.comp.Impress.XMLMetaImporter" );
XML_STRING( sXML_import_impress_styles_service, "com.sun.star.comp.Impress.XMLStylesImporter" );
XML_STRING( sXML_import_impress_content_service, "com.sun.star.comp.Impress.XMLContentImporter" );

XML_STRING( sXML_import_draw_service, "com.sun.star.comp.Draw.XMLImporter" );
XML_STRING( sXML_import_draw_meta_service, "com.sun.star.comp.Draw.XMLMetaImporter" );
XML_STRING( sXML_import_draw_styles_service, "com.sun.star.comp.Draw.XMLStylesImporter" );
XML_STRING( sXML_import_draw_content_service, "com.sun.star.comp.Draw.XMLContentImporter" );

struct XML_SERVICEMAP
{
	const sal_Char* mpService;
	const sal_Char* mpStream;
};

Color aPenColorArray[] =
{
	COL_BLACK, COL_BLUE, COL_GREEN, COL_CYAN, COL_RED,COL_MAGENTA,
	COL_BROWN, COL_GRAY, COL_LIGHTGRAY, COL_LIGHTBLUE, COL_LIGHTGREEN,
	COL_LIGHTCYAN, COL_LIGHTRED, COL_LIGHTMAGENTA, COL_YELLOW, COL_WHITE
};

/*************************************************************************
|*
|* Standard-Konstruktor
|*
\************************************************************************/

SipViewShell::SipViewShell(Window *pParent, const Options& aOptions)
:	pDoc( NULL ),
	pDocShell( NULL ),
	pView( NULL ),
	pWindow( NULL),
	pFuSlideShow(NULL),
	pWorkWindow(NULL),
	rOptions(aOptions),
	bLocked(sal_False),
	nUnlockEvt(0),
	nLockEvt(0),
	aTempDir(NULL, sal_True)
{
//	pWorkWindow = new SIPAppWindow(this);
//	pWorkWindow->SetText(String(SdResId(STR_PLAYER_TITLE)));
//	SetActiveWindow( new SdShowWindow(pParent, NULL) );
//	awt::Size aClient = Application::GetAppWindow()->GetOutputSizePixel();
//	GetActiveWindow()->SetViewShell(this);
//	GetActiveWindow()->SetSizePixel( aClient );
//	GetActiveWindow()->Show();
	aTempDir.EnableKillingFile();	
}

SipViewShell::~SipViewShell()
{
	if( nUnlockEvt )
		Application::RemoveUserEvent( nUnlockEvt );

	StopSlideShow();
	if( pDoc )
	{
		delete pDoc;
		rStorage = NULL;
		pDoc = NULL;
	}
	if( pDocShell )
	{
		delete pDocShell;
		pDocShell = NULL;
	}
	delete pWorkWindow;

	DeleteSlideShow();
}

sal_Bool SipViewShell::KeyInput(const KeyEvent& rKEvt, SdShowWindow* pWin)
{
	if( bLocked )
	{
		Unlock();
		return sal_True;
	}

	sal_Bool bReturn = sal_False;

	if (pWin)
		SetActiveWindow(pWin);

	if (pFuSlideShow)
		bReturn = pFuSlideShow->KeyInput(rKEvt);

	return(bReturn);
}

void SipViewShell::MouseButtonDown(const MouseEvent& rMEvt, SdShowWindow* pWin)
{
	if( bLocked )
	{
		Unlock();
		return;
	}

	if ( pWin && !pWin->HasFocus() )
	{
		pWin->GrabFocus();
		SetActiveWindow(pWin);
	}

	if( rMEvt.IsRight() )
	{
		aPopupMousePos = rMEvt.GetPosPixel();
		Application::PostUserEvent( LINK( this, SipViewShell, ContextMenuHdl ) );
	}
	else
	{
		// MouseEvent in E3dView eintragen
		if( pView )
			pView->SetMouseEvent(rMEvt);

		if (pFuSlideShow)
			pFuSlideShow->MouseButtonDown(rMEvt);
	}
}

IMPL_LINK( SipViewShell, ContextMenuHdl, void*, EMPTYARG )
{
	if( pFuSlideShow == NULL )
		return 0;

	if( pFuSlideShow->IsInputLocked() )
	{
		Application::PostUserEvent( LINK( this, SipViewShell, ContextMenuHdl ) );
		return 0;
	}

	if( bLocked )
	{
		Unlock();
		return 0;
	}

	pFuSlideShow->Pause();
	PopupMenu* pMenu = new PopupMenu( SdResId( MN_PRESI_POPUPMENU ) );

	SdAnimPageList&	aAnimPageList = pFuSlideShow->GetAnimPageList();
	const sal_uInt16 nCurrent = pFuSlideShow->GetCurrentPage();

	pMenu->EnableItem( MNID_PREV_PAGE, aAnimPageList.IsEndlessMode() || !aAnimPageList.IsFirstPage() );
	pMenu->EnableItem( MNID_NEXT_PAGE, aAnimPageList.IsEndlessMode() || !aAnimPageList.IsLastPage() );

	PopupMenu* pSubMenu = pMenu->GetPopupMenu( MNID_MOVETO );
	if( pSubMenu )
	{
		pSubMenu->EnableItem( MNID_FIRST_PAGE, !aAnimPageList.IsFirstPage() );
		pSubMenu->EnableItem( MNID_LAST_PAGE, !aAnimPageList.IsLastPage() );
	
		PopupMenu* pPageMenu = new PopupMenu;

		int nPageCnt = pDoc->GetSdPageCount(PK_STANDARD);
		SdAnimPageList&	rAnimPageList = pFuSlideShow->GetAnimPageList();

		for ( int i = 0; i < nPageCnt; i++)
		{
			if( rAnimPageList.IsPageNumIncluded(i) )
			{
				SdPage* pPage = pDoc->GetSdPage(i, PK_STANDARD);

				if (pPage)
				{
					pPageMenu->InsertItem( MNID_MOVETO_DIRECT + 1 + i, pPage->GetName() );
					if( i == nCurrent )
						pPageMenu->EnableItem( MNID_MOVETO_DIRECT + 1 + i, sal_False );
				}
			}
		}

		pSubMenu->SetPopupMenu( MNID_MOVETO_DIRECT, pPageMenu );
	}

	pSubMenu = pMenu->GetPopupMenu( MNID_RANGE );
	if( pSubMenu )
	{
		sal_Bool bCust = pDoc->IsCustomShow();
		sal_Bool bAll = pDoc->GetPresAll() && !bCust;
		sal_Bool bDia = !( bAll || bCust );
		String aPresPage = pDoc->GetPresPage();

		pSubMenu->CheckItem( MNID_RANGE_ALL, bAll );
		pSubMenu->CheckItem( MNID_RANGE_DIA, bDia );
		pSubMenu->CheckItem( MNID_RANGE_CSHOW, bCust );

		// fill range/from... menu
		PopupMenu* pDiaMenu = new PopupMenu;

		int nPageCnt = pDoc->GetSdPageCount(PK_STANDARD);
		String aPageName;

		for ( int i = 0; i < nPageCnt; i++)
		{
			SdPage* pPage = pDoc->GetSdPage(i, PK_STANDARD);

			if (pPage)
			{
				if( pPage->IsExcluded() )
				{
					aPageName = '(';
					aPageName += pPage->GetName();
					aPageName += ')';
				}
				else
				{
					aPageName = pPage->GetName();
				}

				pDiaMenu->InsertItem( MNID_STARTDIAS + i, aPageName );
				if( bDia && aPresPage == pPage->GetName() )
					pDiaMenu->CheckItem( MNID_STARTDIAS + i, sal_True );
			}
		}

		pSubMenu->SetPopupMenu( MNID_RANGE_DIA, pDiaMenu );

		// fill range/custom show... menu
		PopupMenu* pCShowMenu = new PopupMenu;

		List* pList = pDoc->GetCustomShowList(sal_False);
		if( pList )
		{
			SdCustomShow* pCurrent = bCust ? (SdCustomShow*)pList->GetCurObject() : NULL;

			const sal_uInt16 nShowCount = (sal_uInt16)pList->Count();
			for( sal_uInt16 nShow = 0; nShow < nShowCount; nShow++ )
			{
				SdCustomShow* pShow = (SdCustomShow*)pList->GetObject(nShow);
				pCShowMenu->InsertItem( MNID_CUSTOMSHOWS + nShow, pShow->GetName() );
				if( pShow == pCurrent )
					pCShowMenu->CheckItem( MNID_CUSTOMSHOWS + nShow, sal_True );
			}
		}		
		pSubMenu->SetPopupMenu( MNID_RANGE_CSHOW, pCShowMenu );

		pSubMenu->EnableItem( MNID_RANGE_CSHOW, pList != NULL );
	}

	pMenu->CheckItem( MNID_MOUSE_VISIBLE, pFuSlideShow->IsMouseVisible() );
	pMenu->CheckItem( MNID_AS_PEN, pFuSlideShow->IsMouseAsPen() );

	if( pFuSlideShow->IsMouseAsPen() )
	{
		Color aPenColor( pFuSlideShow->GetPenColor() );
		Menu* pColorMenu = pMenu->GetPopupMenu( MNID_PEN_COLOR );
		for( int i = 0; i < (sizeof(aPenColorArray)/sizeof(Color)); i++ )
			pColorMenu->CheckItem( MNID_PEN_COLOR + 1 + i, aPenColor == aPenColorArray[i] );
	}
		
	pMenu->SetSelectHdl( LINK( this, SipViewShell, ContextMenuSelectHdl ) );
	pMenu->Execute( pWindow, aPopupMousePos );


	delete pMenu;
	pFuSlideShow->Restart();
	return 0;
}

IMPL_LINK( SipViewShell, ContextMenuSelectHdl, Menu *, pMenu )
{
	if( pMenu )
	{
		sal_uInt16 nMenuId = pMenu->GetCurItemId();

		sal_uInt16 nPage = pFuSlideShow->GetCurrentPage();
		SdAnimPageList&	aAnimPageList = pFuSlideShow->GetAnimPageList();

		sal_Bool bSlideChange = sal_False;
		switch( nMenuId )
		{
		case MNID_PREV_PAGE:
			nPage = aAnimPageList.CalcNextPageNum( sal_False );
			if( nPage != aAnimPageList.GetRealNextPageNum() )
				nPage = aAnimPageList.CalcNextPageNum( sal_False );
			bSlideChange = sal_True;
			break;
		case MNID_LAST_PAGE:
			nPage = aAnimPageList.GetLastPageNum();
			bSlideChange = sal_True;
			break;
		case MNID_FIRST_PAGE:
			nPage = aAnimPageList.GetFirstPageNum();
			bSlideChange = sal_True;
			break;
		case MNID_NEXT_PAGE:
			nPage = aAnimPageList.CalcNextPageNum( sal_True );
			if( nPage != aAnimPageList.GetRealNextPageNum() )
				nPage = aAnimPageList.CalcNextPageNum( sal_True );
			bSlideChange = sal_True;
			break;
		case MNID_MOUSE_VISIBLE:
			{
				sal_Bool bVisible = !pFuSlideShow->IsMouseVisible();
				pFuSlideShow->SetMouseVisible( bVisible  );
				pMenu->CheckItem( MNID_MOUSE_VISIBLE, bVisible );
			}
			break;
		case MNID_AS_PEN:
			{
				sal_Bool bAsPen = !pFuSlideShow->IsMouseAsPen();
				pFuSlideShow->SetMouseAsPen( bAsPen );
				pMenu->CheckItem( MNID_AS_PEN, bAsPen );
			}
			break;
		case MNID_LOCK:
			Lock();
			break;
		case MNID_EXIT:
			pFuSlideShow->Terminate();
			break;
		case MNID_RANGE_ALL:
			{
				pDoc->SetPresAll(sal_True);
				pDoc->SetCustomShow(sal_False);
				pFuSlideShow->RestartShow();
			}
		default:
			if( nMenuId > MNID_PEN_COLOR && nMenuId <= MNID_PEN_COLOR + (sizeof(aPenColorArray) / sizeof(Color)) )
			{
				pFuSlideShow->SetMouseAsPen();
				pFuSlideShow->SetPenColor( aPenColorArray[ nMenuId - MNID_PEN_COLOR - 1 ] );
				pMenu->CheckItem( MNID_AS_PEN, pFuSlideShow->IsMouseAsPen() );
			}
			else if( nMenuId > MNID_MOVETO_DIRECT && nMenuId <= MNID_MOVETO_DIRECT_END)
			{
				int nPageId = nMenuId - MNID_MOVETO_DIRECT - 1;
				pFuSlideShow->JumpToPage( nPageId );
			}
			else if( nMenuId >= MNID_CUSTOMSHOWS && nMenuId <= MNID_CUSTOMSHOWS_END )
			{
				sal_uInt32 nShow = nMenuId - MNID_CUSTOMSHOWS;
				pDoc->SetPresAll(sal_True);
				pDoc->SetCustomShow(sal_True);

				List* pList = pDoc->GetCustomShowList(sal_False);
				if( pList )
				{
					pList->First();
					while(nShow--)
						pList->Next();
				}
				pFuSlideShow->RestartShow();
			}
			else if( nMenuId >= MNID_STARTDIAS && nMenuId <= MNID_STARTDIAS_END )
			{
				sal_uInt32 nStartDia = nMenuId - MNID_STARTDIAS;
				pDoc->SetPresAll(sal_False);
				pDoc->SetCustomShow(sal_False);
				pDoc->SetPresPage(pDoc->GetSdPage((sal_uInt16)nStartDia, PK_STANDARD)->GetName());
				pFuSlideShow->RestartShow();
			}
			break;
		}

		if( bSlideChange )
			pFuSlideShow->JumpToPage( nPage );
	}
	
	return 0;
}

void SipViewShell::MouseMove(const MouseEvent& rMEvt, SdShowWindow* pWin)
{
	if( bLocked )
		return;

	if ( pWin )
		SetActiveWindow(pWin);

	// MouseEvent in E3dView eintragen
	if( pView )
		pView->SetMouseEvent(rMEvt);

	if (pFuSlideShow)
		pFuSlideShow->MouseMove(rMEvt);
}

void SipViewShell::MouseButtonUp(const MouseEvent& rMEvt, SdShowWindow* pWin)
{
	if( bLocked )
	{
		Unlock();
		return;
	}

	if ( pWin )
		SetActiveWindow(pWin);

	// MouseEvent in E3dView eintragen
	if( pView )
		pView->SetMouseEvent(rMEvt);

	if (pFuSlideShow && !rMEvt.IsRight() )
		pFuSlideShow->MouseButtonUp(rMEvt);
}


void SipViewShell::Command(const CommandEvent& rCEvt, SdShowWindow* pWin)
{
	if( pFuSlideShow )
		pFuSlideShow->Command(rCEvt);
}

SdPage*	SipViewShell::GetActualPage()
{
	SdPage* pPage = NULL;

	if( pFuSlideShow )		
		pPage = pFuSlideShow->GetActualPage();
	
	if( pPage == NULL && pDoc != NULL )
		pPage = pDoc->GetSdPage( 0, PK_STANDARD );

	return pPage;
}


sal_Bool SipViewShell::Load( const String& rPath )
{
	DeleteSlideShow();

	INetURLObject aURL( rPath );

	if( aURL.GetProtocol() == INET_PROT_NOT_VALID )
	{
		String aURLStr;

		if( ::utl::LocalFileHelper::ConvertPhysicalNameToURL( rPath, aURLStr ) )
			aURL = INetURLObject( aURLStr );
	}

	if( aURL.getExtension().CompareIgnoreCaseToAscii( "sdp" ) == COMPARE_EQUAL )
	{
		return LoadPacked( aURL.GetMainURL(INetURLObject::NO_DECODE) );
	}
	else if( aURL.getExtension().CompareIgnoreCaseToAscii( "sxd" ) == COMPARE_EQUAL ||
		     aURL.getExtension().CompareIgnoreCaseToAscii( "sxi" ) == COMPARE_EQUAL )
	{
		return LoadXML( aURL.GetMainURL(INetURLObject::NO_DECODE) );
	}
	else
	{
		return LoadOwn( aURL.GetMainURL(INetURLObject::NO_DECODE) );
	}
}

void SipViewShell::StartSlideShow()
{
	if( pDoc )
	{
		StopSlideShow();
		pWorkWindow = new SIPAppWindow(this);
		pWorkWindow->SetText(String(SdResId(STR_PLAYER_TITLE)));
		pFuSlideShow = new FuSlideShow( this, pWorkWindow, pDoc, rOptions );
		pFuSlideShow->StartShow();
	}
}

void SipViewShell::StopSlideShow()
{
	if( pFuSlideShow )
	{
		pFuSlideShow->Terminate();
		pFuSlideShow->Destroy();
		pFuSlideShow = NULL;
		DELETEZ( pWorkWindow );
	}
}

void SipViewShell::DeleteSlideShow()
{
 	for( String* pPath = (String*)aTempFiles.First(); pPath; pPath = (String*)aTempFiles.Next() )
 	{
 		osl::File::remove( *pPath );

 		delete (String*) pPath;
 	}
  
 	aTempFiles.Clear();

//  	if( aTempDir.getLength() )
//  	{
//			osl::FileBase::getNormalizedPathFromFileURL( *aTempDir, aUNCPathBefore );
//  		osl::Directory::remove( aUNCPathBefore );
//  		aTempDir = OUString();
//  	}
}

sal_Bool SipViewShell::LoadPacked( const String& rPath )
{
	const OUString aPath( rPath );

	uno::Reference< lang::XMultiServiceFactory >  xSMgr( ::comphelper::getProcessServiceFactory() );
	uno::Reference< util::XArchiver >  xPacker( xSMgr->createInstance( rtl::OUString::createFromAscii("com.sun.star.util.Archiver") ), uno::UNO_QUERY );
	if( !xPacker.is() )
	{
		ErrorBox aErrorBox( NULL, WB_OK, String( SdResId( STR_ERROR_NOARCHIVER ) ) );
		aErrorBox.Execute();
		return sal_False;
	}

	String aProgressTitle( SdResId( STR_UNCOMPRESS ) );
	{
		INetURLObject aURL( rPath );

		if( aURL.GetProtocol() == INET_PROT_NOT_VALID )
		{
			String aURLStr;

			if( ::utl::LocalFileHelper::ConvertPhysicalNameToURL( rPath, aURLStr ) )
				aURL = INetURLObject( aURLStr );
		}

		aProgressTitle += aURL.getName( INetURLObject::LAST_SEGMENT, TRUE, INetURLObject::DECODE_UNAMBIGUOUS );
		aProgressTitle += String::CreateFromAscii("...");
	}

	ProgressDlg aProgrDlg( aProgressTitle, NULL );
	uno::Reference< task::XInteractionHandler >  xInteractionHandler( InteractionHandler_createInstance() );
	uno::Reference< ::com::sun::star::ucb::XProgressHandler >  xProgressHandler( ProgressHandler_createInstance( LINK( &aProgrDlg, ProgressDlg, ProgressHdl ) ) );

	// extract extra data
	OUString aExtraData = xPacker->getExtraData( aPath );
	const OUString aSig1( rtl::OUString::createFromAscii("private:") );
	const OUString aSig2( rtl::OUString::createFromAscii("?simpress") );
	sal_Int32 nIndex1 = aExtraData.indexOf( aSig1 );
	sal_Int32 nIndex2 = aExtraData.indexOf( aSig2 );
	if( nIndex1 != 0 || nIndex2 == -1 )
	{
		ErrorBox aErrorBox( NULL, WB_OK, String( SdResId( STR_ERROR_NOPNG ) ) );
		aErrorBox.Execute();
		return sal_False;
	}
	nIndex1 += aSig1.getLength();

	OUString aTempDoku = aExtraData.copy( nIndex1, nIndex2 - nIndex1 );

#if 0
	// create a temp dir to unpack to
	aTempDirName = aTempDir.GetURL();
	OUString aUNCPathBefore;
	osl::FileBase::getNormalizedPathFromFileURL( aTempDirName, aUNCPathBefore );
	osl::FileBase::getSystemPathFromNormalizedPath( aUNCPathBefore, aTempDirName );
	osl::FileBase::RC rc = osl::Directory::create( aUNCPathBefore );

	if( rc != osl::FileBase::E_None )
	{
		ErrorBox aErrorBox( NULL, WB_OK, String( SdResId( STR_ERROR_NOARCHIVER ) ) ); //todo
		aErrorBox.Execute();
		return sal_False;
	}
#endif

	// remember all temp files
    uno::Reference< container::XIndexAccess >  xFiles( xPacker->getContent( aPath ) );
	if(!xFiles.is())
	{
		ErrorBox aErrorBox( NULL, WB_OK, String( SdResId( STR_ERROR_NOPNG ) ) );
		aErrorBox.Execute();
		return sal_False;
	}

	const sal_Int32 nCount = xFiles->getCount();
	for( sal_Int32 nIndex = 0; nIndex < nCount; nIndex++ )
	{
		uno::Any		aAny( xFiles->getByIndex( nIndex ) );
		OUString		aStr;
		INetURLObject	aURL( aTempDir.GetURL() );

		if( aURL.GetProtocol() == INET_PROT_NOT_VALID )
			aURL = INetURLObject( aTempDir.GetURL() );

		aAny >>= aStr;
		aURL.Append( aStr );
		aTempFiles.Insert( new String( aURL.GetMainURL( INetURLObject::NO_DECODE ) ), CONTAINER_APPEND );
	}

	// unpack all files to temp dir
	uno::Sequence<beans::PropertyValue> aArgs(2);
	aArgs.getArray()[0].Name = rtl::OUString::createFromAscii("InteractionHandler");
	aArgs.getArray()[0].Value <<= xInteractionHandler;
	aArgs.getArray()[1].Name = rtl::OUString::createFromAscii("ProgressHandler");
	aArgs.getArray()[1].Value <<= xProgressHandler;
	uno::Sequence< OUString > files(0);

	if( !xPacker->unpack( aTempDir.GetURL(), aPath, files, aArgs ) )
		return sal_False;

	INetURLObject aURL( aTempDir.GetURL() );

	if( aURL.GetProtocol() == INET_PROT_NOT_VALID )
	{
		aURL = INetURLObject( aTempDir.GetURL() );
	}

	aURL.Append( aTempDoku );

	return LoadOwn( aURL.GetMainURL( INetURLObject::NO_DECODE ) );
}

static const char __FAR_DATA pDocInfoSlot[] = "SfxDocumentInfo";

sal_Bool SipViewShell::LoadOwn( const String& rPath )
{
	INetURLObject aURL( rPath );

	if( aURL.GetProtocol() == INET_PROT_NOT_VALID )
	{
		aURL = INetURLObject( aTempDir.GetURL() );
	}

	aDocName = aURL.getName( INetURLObject::LAST_SEGMENT, TRUE, INetURLObject::DECODE_UNAMBIGUOUS );
	aDocPath = aURL.GetMainURL( INetURLObject::NO_DECODE );
	INetURLObject::SetBaseURL( aURL.GetMainURL( INetURLObject::NO_DECODE ) );

	SfxErrorContext aEC(ERRCTX_SFX_OPENDOC, aDocName);

	SotStorage* pStor;
	rStorage = pStor = new SotStorage( rPath, STREAM_READ | STREAM_SHARE_DENYWRITE );

	sal_Bool bRet = sal_False;

	sal_uInt32 nStorFmt = pStor->GetFormat();

	if ( nStorFmt == SOT_FORMATSTR_ID_STARIMPRESS_50 ||
		 nStorFmt == SOT_FORMATSTR_ID_STARDRAW_50    ||
		 nStorFmt == SOT_FORMATSTR_ID_STARDRAW_40    ||
		 nStorFmt == SOT_FORMATSTR_ID_STARDRAW )
	{
		switch( nStorFmt )
		{
		case SOT_FORMATSTR_ID_STARIMPRESS_50:
		case SOT_FORMATSTR_ID_STARDRAW_50:
			pStor->SetVersion( SOFFICE_FILEFORMAT_50 );
			break;
		case SOT_FORMATSTR_ID_STARDRAW_40:
			pStor->SetVersion( SOFFICE_FILEFORMAT_40 );
			break;
		case SOT_FORMATSTR_ID_STARDRAW:
			pStor->SetVersion( SOFFICE_FILEFORMAT_31);
			break;
		default:
			DBG_ERROR( "unknown file format?!" );
		}

		ByteString aPasswd;

		// check for password
		{
			const String aDocSlotInfo( String::CreateFromAscii(pDocInfoSlot) );
			SotStorageStreamRef aStr = pStor->OpenSotStream(aDocSlotInfo,STREAM_STD_READ);
			if(!aStr.Is())
				return sal_False;
			aStr->SetVersion( pStor->GetVersion() );
	//		aStr->SetBufferSize(STREAM_BUFFER_SIZE);

			SotStorageStream& rStream = *(SotStorageStream*)aStr;

			ByteString		aHeader;
			sal_uInt16		nVersion;
			sal_Bool		bPasswd;
			sal_Int8 b;
			long nVer = rStream.GetVersion();
			rStream.SetVersion( SOFFICE_FILEFORMAT_40 );
			rStream.ReadByteString(aHeader);
			rStream >> nVersion;
			rStream >> b;
			rStream.SetVersion( nVer );
			bPasswd = (sal_Bool)b;

			if( b != 0 )
			{
				SipPasswordDialog aDlg( NULL );
				aDlg.EnableSaveBackground();
				if( aDlg.Execute() != RET_OK )
					return sal_False;

				aPasswd = ByteString( aDlg.GetPasswd(), RTL_TEXTENCODING_ASCII_US );
			}
		}

		//
		StreamMode aStreamMode = STREAM_STD_READWRITE;

		pDoc = new SdDrawDocument(DOCUMENT_TYPE_IMPRESS, NULL);
		pDoc->SetModelStorage(pStor);

		SfxItemPool& rPool = pDoc->GetItemPool();

		String aProgressTitle( SdResId( STR_LOADING ) );
		{
			INetURLObject aURL( rPath );

			if( aURL.GetProtocol() == INET_PROT_NOT_VALID )
			{
				aURL = INetURLObject( aTempDir.GetURL() );
			}

			aProgressTitle += aURL.getName( INetURLObject::LAST_SEGMENT, TRUE, INetURLObject::DECODE_UNAMBIGUOUS );
			aProgressTitle += String::CreateFromAscii("...");
		}
		ProgressDlg aProgrDlg( aProgressTitle, NULL );

        pDoc->SetIOProgressHdl( LINK( &aProgrDlg, ProgressDlg, ProgressHdl ) );

		//		bRet = SvInPlaceObject::Load(pStor);
		{
			SotStorageStreamRef aStm;
			const String aOldeStreamName( String::CreateFromAscii( "\1Ole" ) );
			aStm = pStor->OpenSotStream( aOldeStreamName, STREAM_NOCREATE | STREAM_READ | STREAM_SHARE_DENYWRITE );
			if( aStm->GetError() == SVSTREAM_OK )
			{
				aStm->Seek( 4 );
				sal_uInt32 nLnk;
				*aStm >> nLnk;
			}
		}

	    aProgrDlg.EnterWait();

	    sal_Bool bIsEmptyStreams = sal_False;

		const String aSfxStyleSheets( pSfxStyleSheets );
	    if (pStor->IsStream(aSfxStyleSheets))
	    {
	        SotStorageStreamRef aPoolStm = pStor->OpenSotStream(aSfxStyleSheets,
	                                                        aStreamMode);
	        bRet = aPoolStm->GetError() == 0;

	        if (!bRet)
	        {
	            // Stream konnte nicht geoeffnet werden
	            // Kann der Stream denn als read geoeffnet werden?
	            aPoolStm.Clear();
	            aStreamMode = STREAM_STD_READ;
	            aPoolStm = pStor->OpenSotStream(aSfxStyleSheets, aStreamMode);
	            bRet = aPoolStm->GetError() == 0;
	        }

	        // Pool laden
	        if (bRet)
	        {
	            aPoolStm->SetVersion(pStor->GetVersion());
				rPool.SetFileFormatVersion((sal_uInt16)pStor->GetVersion());
	            aPoolStm->SetBufferSize(POOL_BUFFER_SIZE);
				rPool.Load(*aPoolStm);
	        }
	        bRet = aPoolStm->GetError() == 0;
	        DBG_ASSERT(bRet, "Fehler beim Laden des Item-Pools");

	        // StyleSheet-Pool laden
	        if (bRet)
	        {
				SfxStyleSheetPool* pPool = (SfxStyleSheetPool*) pDoc->GetStyleSheetPool();
	            SfxStyleSheetPool* pSSSP = pPool;
	            pPool->Load(*aPoolStm);
	            aPoolStm->SetBufferSize(0);
	            bRet = aPoolStm->GetError() == 0;
	            DBG_ASSERT(bRet, "Fehler beim Laden des StyleSheet-Pools");
	        }

	        if (!bRet)
	        {
	            pStor->SetError(aPoolStm->GetError());
	        }
	    }
	    else
	    {
	        // wenn der Stream gar nicht vorhanden ist, gilt das trotzdem als
	        // Erfolg (fuer das Laden ungeaenderter OLE-Objekte)
	        bIsEmptyStreams = sal_True;
	        bRet = sal_True;
	    }

	    // Model der Drawing script::Engine laden
	    if (bRet)
	    {
	        // altes oder neues Format enthalten?
	        sal_Bool bAcceptableStreamFound = sal_False;
	        SotStorageStreamRef aDocStm;
			const String aStarDrawDoc( pStarDrawDoc );
			const String aStarDrawDoc3( pStarDrawDoc3 );
	        if (pStor->IsStream(aStarDrawDoc))
	        {
	            bAcceptableStreamFound = sal_True;
	            aDocStm = pStor->OpenSotStream(aStarDrawDoc, aStreamMode);
	        }
	        else if (pStor->IsStream(aStarDrawDoc3))
	        {
	            bAcceptableStreamFound = sal_True;
	            aDocStm = pStor->OpenSotStream(aStarDrawDoc3, aStreamMode);
	        }

	        if (bAcceptableStreamFound)
	        {
	            aDocStm->SetVersion(pStor->GetVersion());
	            bRet = aDocStm->GetError() == 0;
	            if(bRet)
	            {
					aDocStm->SetBufferSize(DOCUMENT_BUFFER_SIZE);
	                aDocStm->SetKey( aPasswd ); // Passwort setzen
	                *aDocStm >> *pDoc;
	                bRet = aDocStm->GetError() == 0;

	                if (!bRet)
	                {
						// kein Passwort gesetzt --> Datei marode
	                    if (aPasswd.Len() == 0)
	                    {
	                        pStor->SetError(ERRCODE_SFX_DOLOADFAILED);

	                    }
	                    // Passwort gesetzt --> war wohl falsch
	                    else
	                    {
	                        pStor->SetError(ERRCODE_SFX_WRONGPASSWORD);
	                    }
	                }

					aDocStm->SetBufferSize(0);
	            }
	            bIsEmptyStreams = sal_False;
	        }
	        // wenn der Stream gar nicht vorhanden ist, gilt das trotzdem als
	        // Erfolg (fuer das Laden ungeaenderter OLE-Objekte)
	    }

	    if (bRet && pDoc)
	    {
	        if (bIsEmptyStreams == sal_True)
	        {
	            pDoc->NewOrLoadCompleted(NEW_DOC);
	        }
	        else
	        {
	            pDoc->NewOrLoadCompleted(DOC_LOADED);
	        }

			SdrOutliner& rOutliner = pDoc->GetDrawOutliner();
			rOutliner.SetCalcFieldValueHdl(LINK(SIP_APP(), SIPApp, CalcFieldValueHdl));
		}

	    aProgrDlg.LeaveWait();

	    if (bRet)
		{
#if 0
			UpdateTablePointers();

		    if (GetCreateMode() == SFX_CREATE_MODE_EMBEDDED &&
		        SfxInPlaceObject::GetVisArea().IsEmpty())
	    	{
	        	// Leere VisArea: auf Seitengroesse setzen
	        	SdPage* pPage = pDoc->GetSdPage(0, PK_STANDARD);

	        	if (pPage)
	            	SetVisArea(awt::Rectangle(pPage->GetAllObjBoundRect()));
		    }

	        FinishedLoading(SFX_LOADED_ALL);
#endif
		}

		pDoc->SetIOProgressHdl( Link() );
	}
	else
	{
		if( pStor->GetError() == 0 )
			pStor->SetError(SVSTREAM_WRONGVERSION);
	}

	if(!bRet || pDoc == NULL)
	{
		delete pDoc;
		pDoc = NULL;

		if( pStor->GetError() != 0 )
		{
			ErrorHandler::HandleError( pStor->GetError() );
		}

		rStorage = NULL;
	}

	return bRet;
}

sal_Bool SipViewShell::LoadXML( const String& rPath )
{
	SotStorage* pStorage;
	rStorage = pStorage = new SotStorage( rPath, STREAM_READ | STREAM_SHARE_DENYWRITE );

	pDocShell = new SdDrawDocShell( pStorage );

	pDoc = new SdDrawDocument(DOCUMENT_TYPE_IMPRESS, (SfxObjectShell*)pDocShell);
	pDoc->SetModelStorage(rStorage);
	pDocShell->SetDoc( pDoc );
	
	pDoc->NewOrLoadCompleted( NEW_DOC );
	pDoc->CreateFirstPages();
	pDoc->StopWorkStartupDelay();

	uno::Reference< frame::XModel > mxModel( pDocShell->GetModel() );
	if( !mxModel.is() )
	{
		DBG_ERROR("Got NO Model in XMLImport");
		return FALSE;
	}

	uno::Reference<lang::XMultiServiceFactory> xServiceFactory( ::comphelper::getProcessServiceFactory() );
	
	if( !xServiceFactory.is() )
	{
		DBG_ERROR( "XMLReader::Read: got no service manager" );
		return FALSE;
	}

	uno::Reference< uno::XInterface> xXMLParser( xServiceFactory->createInstance( OUString( RTL_CONSTASCII_USTRINGPARAM( "com.sun.star.xml.sax.Parser" ) ) ) );
	
	if( !xXMLParser.is() )
	{
		DBG_ERROR( "com.sun.star.xml.sax.Parser service missing" );
		return FALSE;
	}

	mxModel->lockControllers();

	sal_Bool	bRet = sal_False;

	do
	{
		UINT16		nStyleFamilyMask = 0;
		sal_Bool	bLoadDoc = TRUE;

		try
		{
//			uno::Reference< document::XEmbeddedObjectResolver > xObjectResolver;
//			SvXMLEmbeddedObjectHelper *pObjectHelper = 0;

			uno::Reference< document::XGraphicObjectResolver >	xGrfResolver;
			SvXMLGraphicHelper*	pGraphicHelper = 0;

			if( pStorage )
			{
/*
				SvPersist *pPersist = mrDocShell.GetDoc()->GetPersist();
				if( pPersist )
				{
					pObjectHelper = SvXMLEmbeddedObjectHelper::Create(*pStorage, *pPersist, EMBEDDEDOBJECTHELPER_MODE_READ, sal_False );
					xObjectResolver = pObjectHelper;
				}
*/
				pGraphicHelper = SvXMLGraphicHelper::Create( *pStorage, GRAPHICHELPER_MODE_READ );
				xGrfResolver = pGraphicHelper;
			}

			uno::Reference< task::XStatusIndicator > mxStatusIndicator;
/*
			if( mbShowProgress )
			{
				CreateStatusIndicator();
				
				if( mxStatusIndicator.is() )
					mxStatusIndicator->start( ::rtl::OUString::createFromAscii( "XML Import" ), 100 );
			}
*/
			uno::Reference< lang::XComponent > xComponent( mxModel, uno::UNO_QUERY ); 

//			XML_SERVICEMAP aServices[4];
// don't need meta stream for player
//			aServices[0].mpService = sXML_import_impress_meta_service; // IsDraw() ? sXML_import_draw_meta_service : sXML_import_impress_meta_service;
//			aServices[0].mpStream  = sXML_metaStreamName;

			XML_SERVICEMAP aServices[] = {
					{sXML_import_impress_styles_service, // IsDraw() ? sXML_import_draw_styles_service : sXML_import_impress_styles_service;
					 sXML_styleStreamName},
					{sXML_import_impress_content_service, // IsDraw() ? sXML_import_draw_content_service : sXML_import_impress_content_service;
					 sXML_contentStreamName},
					{NULL,NULL}
			};

			XML_SERVICEMAP* pServices;
			for( pServices = aServices; pServices->mpService; pServices++ )
			{
				xml::sax::InputSource					aParserInput;
				SotStorageStreamRef						xIStm;
				uno::Reference< io::XActiveDataSource > xSource;

//				aParserInput.sSystemId = mrMedium.GetName();

				if( pStorage )
				{
					String aStreamName = OUString::createFromAscii( pServices->mpStream );

					if( !pStorage->IsStream( aStreamName ) )
					{
						if( pServices->mpStream == sXML_contentStreamName )
						{
							aStreamName = String( RTL_CONSTASCII_USTRINGPARAM( sXML_oldContentStreamName ) );
							pServices->mpService = sXML_import_impress_service; // IsDraw() ? sXML_import_draw_service : sXML_import_impress_service;
							if( !pStorage->IsStream( aStreamName ) )
							{
								continue;
							}
						}
						else
						{
							continue;
						}
					}

					xIStm = pStorage->OpenSotStream( aStreamName, STREAM_READ | STREAM_NOCREATE );

					// try for old content stream name with capital 'C'
					if( !xIStm.Is() && pServices->mpStream == sXML_contentStreamName )
						xIStm = pStorage->OpenSotStream( OUString( RTL_CONSTASCII_USTRINGPARAM( sXML_oldContentStreamName ) ), STREAM_READ | STREAM_NOCREATE );

					if( xIStm.Is() )
					{
						xIStm->SetBufferSize( 16 * 1024 );
						aParserInput.aInputStream = new utl::OInputStreamWrapper( *xIStm );
					}
					else
					{
						DBG_ERROR( "could not open Content stream" );
						break;
					}
				}

				if( aParserInput.aInputStream.is() )
				{
					uno::Reference< xml::sax::XParser > xParser( xXMLParser, uno::UNO_QUERY );

					uno::Sequence< uno::Any > aArgs( ( mxStatusIndicator.is() ? 1 : 0 ) + ( xGrfResolver.is() ? 1 : 0 ) );
					uno::Any* pArgs = aArgs.getArray();
					if( xGrfResolver.is() )
						*pArgs++ <<= xGrfResolver;

					if( mxStatusIndicator.is() )
						*pArgs   <<= mxStatusIndicator;

					uno::Reference< xml::sax::XDocumentHandler> xDocHandler( xServiceFactory->createInstanceWithArguments( OUString::createFromAscii( pServices->mpService ), aArgs), uno::UNO_QUERY );

					if( xDocHandler.is() )
					{
						uno::Reference< document::XImporter > xImporter( xDocHandler, uno::UNO_QUERY );
						if( xImporter.is() )
						{
							xImporter->setTargetDocument( xComponent );
							xParser->setDocumentHandler( xDocHandler );

							if( !pStorage )
								uno::Reference< io::XActiveDataControl >( xSource, uno::UNO_QUERY )->start();

							xParser->parseStream( aParserInput );				
							bRet = sal_True;
						}
					}
				}
			}

			if( pGraphicHelper )
				SvXMLGraphicHelper::Destroy( pGraphicHelper );

//			if( pObjectHelper )
//				SvXMLEmbeddedObjectHelper::Destroy( pObjectHelper );
		}
		catch( uno::Exception e )
		{
	#ifdef DEBUG
			ByteString aError( "uno Exception caught while importing:\n" );
			aError += ByteString( String( e.Message), RTL_TEXTENCODING_ASCII_US );
			DBG_ERROR( aError.GetBuffer() );
	#endif
		}
	} while( 0 );

	mxModel->unlockControllers();

	return bRet;
}


void SipViewShell::SetActiveWindow(SdShowWindow* pWin)
{
	pWindow = pWin;
}

void SipViewShell::Resize()
{
	if( pDoc == NULL )
		return;

	Window* pShowWindow = pWorkWindow; // Application::GetAppWindow();

	SdPage* pP          = pDoc->GetSdPage(0, PK_STANDARD);
	Size aPageSize( pP->GetSize() );
	aPageSize.Width()  -= pP->GetRgtBorder() + pP->GetLftBorder() - 2;
	aPageSize.Height() -= pP->GetUppBorder() + pP->GetLwrBorder() - 2;

	// Zoom-Faktor bestimmen
	Size aWinSizePix( SIP_APPWINDOW.GetOutputSizePixel() );

	// sonst wird der MapMode falsch berechnet, aber wieso ?????
	aWinSizePix.Width()  -= 1;
	aWinSizePix.Height() -= 1;

	MapMode aMapMode(MAP_100TH_MM, Point(0,0), Fraction(1,1), Fraction(1,1));
	pShowWindow->SetMapMode(aMapMode);

	Size aWinSize( pShowWindow->PixelToLogic(aWinSizePix) );
	long nZoomX 	 = aWinSize.Width()  * 1000 / aPageSize.Width();
	long nZoomY 	 = aWinSize.Height() * 1000 / aPageSize.Height();
	long nZoom		 = Min(nZoomY, nZoomX);

	Fraction aZoom(nZoom, 1000);

	// MapMode bestimmen
	aMapMode = pShowWindow->GetMapMode();
	aMapMode.SetScaleX(aZoom);
	aMapMode.SetScaleY(aZoom);
	pShowWindow->SetMapMode(aMapMode);

	// durch Zoomen veraendert
	aWinSize = pShowWindow->PixelToLogic(aWinSizePix);

	// Ursprung des sichtbaren Seitenbereichs im Fenster
	Point aPageOrigin( (aWinSize.Width() - aPageSize.Width()) / 2, (aWinSize.Height() - aPageSize.Height()) / 2 );

	// MapMode-Origin so berechnen, dass das Seiteninnere richtig liegt,
	// wenn die Seite bei (0,0) dargestellt wird
	Point aMMOrigin(aPageOrigin);
	aMMOrigin.X() -= pP->GetLftBorder();
	aMMOrigin.Y() -= pP->GetUppBorder();

	// auf Pixelkoordinaten runden
	aMMOrigin = pShowWindow->PixelToLogic(pShowWindow->LogicToPixel(aMMOrigin));

	aMapMode.SetOrigin (aMMOrigin);
	pShowWindow->SetMapMode(aMapMode);

	pShowWindow->Invalidate();

	if( pFuSlideShow )
		pFuSlideShow->Resize(pShowWindow->GetOutputSizePixel());
}

void SipViewShell::Paint(const Rectangle& rRect, SdShowWindow* pWin)
{
	if( pView )
		pView->InitRedraw(pWin, Region (rRect));
}

void SipViewShell::Lock()
{
	DBG_ASSERT( !bLocked, "someone tried to lock a locked presentation?" );

	// create new lock event
	if( nLockEvt == 0 )
		nLockEvt = Application::PostUserEvent( LINK( this, SipViewShell, LockHdl ) );

}

IMPL_LINK( SipViewShell, LockHdl, void*, p )
{
	nLockEvt = 0;
	if( pFuSlideShow == NULL )
		return 0;

	if( pFuSlideShow->IsInputLocked() )
	{
		nLockEvt = Application::PostUserEvent( LINK( this, SipViewShell, LockHdl ) );
		return 0;
	}

	pFuSlideShow->Pause();
	{
		const String aTitle( SdResId( STR_GIVE_KEYWORD_LOCK ) );
		const String aKeyword( SdResId( STR_KEYWORD ) );
		const String aConfirm( SdResId( STR_KEYWORD_CONFIRM ) );

		SipPasswordDialog aDlg( pWorkWindow, sal_True );
		aDlg.SetPasswd( aPasswd );
		aDlg.SetMinLen(2);
		aDlg.SetText( aTitle );
		aDlg.SetPasswdText( aKeyword );
		aDlg.SetConfirmText( aConfirm );
		aDlg.EnableSaveBackground();

		if( aDlg.Execute() == RET_OK )
		{
			aPasswd = aDlg.GetPasswd();
			bLocked = sal_True;
		}
	}

	DBG_ASSERT( !pFuSlideShow->IsInputLocked(), "IsInEffect!!!" );

	pFuSlideShow->Restart();

	return 0;
}

void SipViewShell::Unlock()
{
	DBG_ASSERT( bLocked, "someone tried to unlock a not locked presentation?" );

	// create new unlock event
	if( nUnlockEvt == 0 )
		nUnlockEvt = Application::PostUserEvent( LINK( this, SipViewShell, UnlockHdl ) );
}

IMPL_LINK( SipViewShell, UnlockHdl, void*, p )
{
	nUnlockEvt = 0;
	if( pFuSlideShow == NULL )
		return 0;

	if( pFuSlideShow->IsInputLocked() )
	{
		nUnlockEvt = Application::PostUserEvent( LINK( this, SipViewShell, UnlockHdl ) );
		return 0;
	}

	pFuSlideShow->Pause();

	const String aTitle( SdResId( STR_GIVE_KEYWORD_UNLOCK ) );
	const String aKeyword( SdResId( STR_KEYWORD ) );
	const String aConfirm( SdResId( STR_KEYWORD_CONFIRM ) );

	do
	{
		SipPasswordDialog aDlg( pWorkWindow );
		aDlg.SetMinLen(2);
		aDlg.SetTimeOut( 30000 );
		aDlg.SetText( aTitle );
		aDlg.SetPasswdText( aKeyword );
		aDlg.SetConfirmText( aConfirm );
		aDlg.EnableSaveBackground();

		if( aDlg.Execute() != RET_OK )
			break;

		if( aDlg.GetPasswd() == aPasswd )
			bLocked = sal_False;

	} while( bLocked );

	DBG_ASSERT( !pFuSlideShow->IsInputLocked(), "IsInEffect!!!" );
	pFuSlideShow->Restart();

	return 0L;
}

sal_Bool SipViewShell::Close()
{
	if( bLocked )
	{
		Unlock();
		return sal_False;
	}

	StopSlideShow();
	return sal_True;
}

