/*************************************************************************
 *
 *  $RCSfile: swlib.cxx,v $
 *
 *  $Revision: 1.9 $
 *
 *  last change: $Author: fme $ $Date: 2001/07/26 06:39:04 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

//Kein precompiled includen

#pragma hdrstop

#define _SWLIB_CXX

#ifndef _SFX_OBJFAC_HXX //autogen
#include <sfx2/docfac.hxx>
#endif
#ifndef _SFX_DOCFILT_HACK_HXX //autogen
#include <sfx2/docfilt.hxx>
#endif
#ifndef _SFX_FCONTNR_HXX //autogen
#include <sfx2/fcontnr.hxx>
#endif
#ifndef _SFXDOCFILE_HXX //autogen
#include <sfx2/docfile.hxx>
#endif
#ifndef _SFXAPP_HXX //autogen
#include <sfx2/app.hxx>
#endif
#ifndef _INETTYPE_HXX //autogen
#include <svtools/inettype.hxx>
#endif
#ifndef _MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif
#ifndef _PARHTML_HXX //autogen
#include <svtools/parhtml.hxx>
#endif

#include <swdll.hxx>
#include <swdll0.hxx> // wird vom makefile generiert
#ifndef _SWMODULE_HXX //autogen
#include <swmodule.hxx>
#endif
#ifndef _SWWDOCSH_HXX //autogen
#include <wdocsh.hxx>
#endif
#ifndef _SWGLOBDOCSH_HXX //autogen
#include <globdoc.hxx>
#endif
#ifndef _SHELLIO_HXX //autogen
#include <shellio.hxx>
#endif
#ifndef _SO_CLSIDS_HXX
#include <so3/clsids.hxx>
#endif

#include <svtools/moduleoptions.hxx>

#include <app.hrc>
#include <web.hrc>
#include <globdoc.hrc>

#ifndef _IODETECT_HXX
#include <iodetect.hxx>
#endif

#define C2S(cChar) String::CreateFromAscii(cChar)
//os: the Icon Id is unused since start of VCL
#define ICON_ID_INVALID 0

inline BOOL IsDocShellRegistered()
{
// zu dem Zeitpunkt ist das Interface der DocShell leider noch nicht
// registriert!!

//	return 0 != (SFX_APP()->GetInterfaceByIdImpl( SfxInterfaceId(SW_DOCSHELL) ));
    return SvtModuleOptions().IsWriter();
}

USHORT AutoDetec( const String& FileName, USHORT & rVersion );

IO_DETECT_IMPL1
IO_DETECT_IMPL2
IO_DETECT_IMPL3
IO_DETECT_IMPL4

//-------------------------------------------------------------------------


SFX_IMPL_MODULE_LIB(Sw, String::CreateFromAscii(DLL_NAME))

TYPEINIT1( SwModuleDummy, SfxModule );


//-------------------------------------------------------------------------
SFX_IMPL_OBJECTFACTORY_MOD(SwDocShell, 						\
		SFXOBJECTSHELL_STD_NORMAL|SFXOBJECTSHELL_HASMENU,   \
		swriter, 											\
		SvGlobalName(SO3_SW_CLASSID),						\
		Sw,													\
		DLL_NAME)
{
	String aTypeName( String::CreateFromAscii("StarWriter 5.0" ));
	String sEmpty;

	SfxObjectFactory& rFactory = (SfxObjectFactory&)Factory();
	rFactory.SetDocumentServiceName(C2S("com.sun.star.text.TextDocument"));
	SfxFactoryFilterContainer *pFltContainer = rFactory.GetFilterContainer( FALSE );
	BOOL bInsAllFlt = !pFltContainer || !pFltContainer->GetFilterCount();
	if( bInsAllFlt )
	{
/*------------------------------------
JP 15.07.98: laut MA/ST: nur die absolut notwendigen registrieren
		ULONG nSW40 = SotExchange::RegisterSotFormatName(
										SOT_FORMATSTR_ID_STARWRITER_40 );
		ULONG nSW30 = SotExchange::RegisterSotFormatName(
										SOT_FORMATSTR_ID_STARWRITER_30 );


		rFactory.RegisterFilter( "StarWriter 4.0",
								"*.sdw",
								SFX_FILTER_IMPORT | SFX_FILTER_EXPORT |
								SFX_FILTER_ALIEN | SFX_FILTER_OWN |
								SFX_FILTER_TEMPLATE,
								nSW40,
								"SW/",
								aTypeName,
								ICON_ID_INVALID,
								INetContentTypes::GetContentType(
												CONTENT_TYPE_APP_VND_WRITER ),
								FILTER_SW4 );

		rFactory.RegisterFilter( "StarWriter 4.0 Vorlage/Template",
								"*.vor",
								SFX_FILTER_IMPORT | SFX_FILTER_EXPORT |
								SFX_FILTER_OWN | SFX_FILTER_TEMPLATE |
								SFX_FILTER_ALIEN | SFX_FILTER_TEMPLATEPATH,
								nSW40,
								"sW/",
								aTypeName,
								ICON_ID_INVALID,
								INetContentTypes::GetContentType(
												CONTENT_TYPE_APP_VND_WRITER ),
								FILTER_SW4V );

		rFactory.RegisterFilter( "StarWriter 3.0",
								"*.sdw",
								SFX_FILTER_IMPORT | SFX_FILTER_EXPORT |
								SFX_FILTER_ALIEN | SFX_FILTER_TEMPLATE |
								SFX_FILTER_OWN,
								nSW30 ,
								"SW/",
								aTypeName,
								ICON_ID_INVALID,
								INetContentTypes::GetContentType(
												CONTENT_TYPE_APP_VND_WRITER ),
								FILTER_SW3 );

		rFactory.RegisterFilter( "StarWriter 3.0 Vorlage/Template",
								"*.vor",
								SFX_FILTER_IMPORT | SFX_FILTER_EXPORT |
								SFX_FILTER_ALIEN | SFX_FILTER_TEMPLATE |
								SFX_FILTER_OWN | SFX_FILTER_TEMPLATEPATH,
								nSW30,
								"sW/",
								aTypeName,
								ICON_ID_INVALID,
								INetContentTypes::GetContentType(
												CONTENT_TYPE_APP_VND_WRITER ),
								FILTER_SW3V );

#ifndef MAC
		rFactory.RegisterFilter( "Text MAC",
								"*.txt",
								SFX_FILTER_IMPORT | SFX_FILTER_EXPORT | SFX_FILTER_ALIEN,
								0,
								"TEXT",
								aTypeName,
								ICON_ID_INVALID,
								"text/plain",
								sTextMac );
#endif
#ifndef UNX
		rFactory.RegisterFilter( "Text Unix",
								"*.txt",
								SFX_FILTER_IMPORT | SFX_FILTER_EXPORT | SFX_FILTER_ALIEN,
								0,
								"TEXT",
								aTypeName,
								ICON_ID_INVALID,
								"text/plain",
								sTextUnx );
#endif

#ifndef PM2
		rFactory.RegisterFilter( "Text DOS",
								"*.txt",
								SFX_FILTER_IMPORT | SFX_FILTER_EXPORT | SFX_FILTER_ALIEN,
								0,
								"TEXT",
								aTypeName,
								ICON_ID_INVALID,
								"text/plain",
								sTextDos );
#endif

		rFactory.RegisterFilter( "MS WinWord 95",
								"*.doc",
								SFX_FILTER_IMPORT | SFX_FILTER_EXPORT | SFX_FILTER_ALIEN,
								Exchange::RegisterFormatName( "MSWordDoc" ),
								"TEXT",
								aTypeName,
								ICON_ID_INVALID,
								"application/msword",
								sWW6 );

		rFactory.RegisterFilter( "MS WinWord 6.0",
								"*.doc",
								SFX_FILTER_IMPORT | SFX_FILTER_EXPORT | SFX_FILTER_ALIEN,
								Exchange::RegisterFormatName( "MSWordDoc" ),
								"TEXT",
								aTypeName,
								ICON_ID_INVALID,
								"application/msword",
								sWW6 );

		rFactory.RegisterFilter( "MS WinWord 97",
								"*.doc",
								SFX_FILTER_IMPORT | SFX_FILTER_ALIEN,
								Exchange::RegisterFormatName( "MSWordDoc" ),
								"TEXT",
								aTypeName,
								ICON_ID_INVALID,
								"application/msword",
								sWW8 );

		rFactory.RegisterFilter( "MS Excel 5.0/95 (StarWriter)",
								"*.x??",
								SFX_FILTER_IMPORT | SFX_FILTER_ALIEN,
								Exchange::RegisterFormatName( "Biff5" ),
								"XLS ",
								aTypeName,
								ICON_ID_INVALID,
								sEmpty,
								sExcel );

		rFactory.RegisterFilter( "StarWriter 2.0",
								"*.sdw",
								SFX_FILTER_IMPORT |
								SFX_FILTER_ALIEN | SFX_FILTER_TEMPLATE,
								0,
								"SDwr",
								aTypeName,
								ICON_ID_INVALID,
								sEmpty,
								FILTER_SWG );

		rFactory.RegisterFilter( "StarWriter 2.0 Vorlage/Template",
								"*.vor",
								SFX_FILTER_IMPORT |
								SFX_FILTER_ALIEN | SFX_FILTER_TEMPLATE |
								SFX_FILTER_TEMPLATEPATH,
								0,
								"SDwv",
								aTypeName,
								ICON_ID_INVALID,
								sEmpty,
								FILTER_SWGV );

		rFactory.RegisterFilter( "StarWriter 1.0",
								"*.sdw",
								SFX_FILTER_IMPORT | SFX_FILTER_ALIEN,
								0,
								"SDwr",
								aTypeName,
								ICON_ID_INVALID,
								sEmpty,
								sSwg1 );

		rFactory.RegisterFilter( "Lotus 1-2-3 1.0 (WIN) (StarWriter)",
								"*.wk?",
								SFX_FILTER_IMPORT | SFX_FILTER_ALIEN,
								0,
								"TEXT",
								aTypeName,
								ICON_ID_INVALID,
								sEmpty,
								sLotusW );

		rFactory.RegisterFilter( "Lotus 1-2-3 1.0 (DOS) (StarWriter)",
								"*.wk?",
								SFX_FILTER_IMPORT | SFX_FILTER_ALIEN,
								0,
								"TEXT",
								aTypeName,
								ICON_ID_INVALID,
								sEmpty,
								sLotusD );

		rFactory.RegisterFilter( "MS Excel 4.0 (StarWriter)",
								"*.x??",
								SFX_FILTER_IMPORT | SFX_FILTER_ALIEN,
								0,
								"XLS ",
								aTypeName,
								ICON_ID_INVALID,
								sEmpty,
								sExcel );


		rFactory.RegisterFilter( "MS PMWord 1.x / WinWord 1.x",
								"*.doc",
								SFX_FILTER_IMPORT | SFX_FILTER_ALIEN,
								0,
								"TEXT",
								aTypeName,
								ICON_ID_INVALID,
								sEmpty,
								sWW1 );





----------------------------------------------------------*/
	}

	rFactory.GetFilterContainer()->SetDetectFilter( &SwDLL::DetectFilter );
/*
	String sSwCopyRight(ByteString("SW/"), RTL_TEXTENCODING_MS_1252);
	rFactory.RegisterFilter( aTypeName,
							String::CreateFromAscii("*.sdw"),
							SFX_FILTER_IMPORT | SFX_FILTER_EXPORT |
							SFX_FILTER_OWN | SFX_FILTER_TEMPLATE,
							SOT_FORMATSTR_ID_STARWRITER_50,
							sSwCopyRight,
							aTypeName,
							ICON_ID_INVALID,
							INetContentTypes::GetContentType(
												CONTENT_TYPE_APP_VND_WRITER ),
							String::CreateFromAscii(FILTER_SW5) );

	rFactory.RegisterFilter( C2S("StarWriter 5.0 Vorlage/Template"),
							C2S("*.vor"),
							SFX_FILTER_IMPORT | SFX_FILTER_EXPORT |
							SFX_FILTER_OWN | SFX_FILTER_TEMPLATE |
							SFX_FILTER_TEMPLATEPATH,
							SOT_FORMATSTR_ID_STARWRITER_50,
							sSwCopyRight,
							aTypeName,
							ICON_ID_INVALID,
							INetContentTypes::GetContentType(
												CONTENT_TYPE_APP_VND_WRITER ),
							C2S(FILTER_SW5V) );

#if defined W40 || defined UNX || defined PM2
// Windows 95, OS2 kann htm & html
// Unix auch
	rFactory.RegisterFilter( C2S("HTML (StarWriter)"),
							C2S("*.html;*.htm"),
							SFX_FILTER_IMPORT | SFX_FILTER_EXPORT |
							SFX_FILTER_ALIEN | SFX_FILTER_ASYNC,
							0,
							C2S("TEXT"),
							aTypeName,
							ICON_ID_INVALID,
							C2S("text/html"),
							C2S(sHTML) );
#else
	rFactory.RegisterFilter( C2S("HTML (StarWriter)"),
							C2S("*.htm"),
							SFX_FILTER_IMPORT | SFX_FILTER_EXPORT |
							SFX_FILTER_ALIEN | SFX_FILTER_ASYNC,
							0,
							C2S("TEXT"),
							aTypeName,
							ICON_ID_INVALID,
							C2S("text/html"),
							C2S(sHTML) );
#endif

	rFactory.RegisterFilter( C2S("Rich Text Format"),
							C2S("*.rtf"),
							SFX_FILTER_IMPORT | SFX_FILTER_EXPORT | SFX_FILTER_ALIEN,
							0,
							C2S("TEXT"),
							aTypeName,
							ICON_ID_INVALID,
							sEmpty,
							C2S(FILTER_RTF) );

	rFactory.RegisterFilter( C2S("Text"),
							C2S("*.txt"),
							SFX_FILTER_IMPORT | SFX_FILTER_EXPORT | SFX_FILTER_ALIEN,
							0,
							C2S("TEXT"),
							aTypeName,
							ICON_ID_INVALID,
							C2S("text/plain"),
							C2S(FILTER_ANSI) );


#if !defined(WIN) && !defined(WNT)
	rFactory.RegisterFilter( C2S("Text WIN"),
							C2S("*.txt"),
							SFX_FILTER_IMPORT | SFX_FILTER_EXPORT | SFX_FILTER_ALIEN,
							0,
							C2S("TEXT"),
							aTypeName,
							ICON_ID_INVALID,
							sEmpty,
							C2S(sTextWin) );
#endif

// folgende Filter nur zum Debuggen:
#ifdef DEBUG_SH
	rFactory.RegisterFilter( C2S("W4W (internal)"),
							C2S("*."),
							SFX_FILTER_IMPORT | SFX_FILTER_ALIEN,
							0,
							C2S("TEXT"),
							aTypeName,
							ICON_ID_INVALID,
							sEmpty,
							C2S("W4_INT") );

#endif // DEBUG_SH

#if !( defined(PRODUCT) || defined(MAC) || defined(PM2))

	rFactory.RegisterFilter( C2S("DEBUG (internal)"),
							C2S("*.db"),
							SFX_FILTER_EXPORT | SFX_FILTER_ALIEN,
							0,
							C2S("TEXT"),
							aTypeName,
							ICON_ID_INVALID,
							sEmpty,
							C2S("DEBUG") );

	rFactory.RegisterFilter( C2S("UNDO (internal)"),
							C2S("*.und"),
							SFX_FILTER_EXPORT | SFX_FILTER_ALIEN,
							0,
							C2S("TEXT"),
							aTypeName,
							ICON_ID_INVALID,
							sEmpty,
							C2S("UNDO") );
#endif
*/
}

//-------------------------------------------------------------------------
SFX_IMPL_OBJECTFACTORY_MOD(SwWebDocShell, 								\
		SFXOBJECTSHELL_STD_NORMAL|SFXOBJECTSHELL_HASMENU, swriter/web, 	\
		SvGlobalName(SO3_SWWEB_CLASSID),								\
		Sw,																\
		DLL_NAME)
{
	const String aTypeName( C2S("StarWriter/Web 5.0") );

	SfxObjectFactory& rFactory = (SfxObjectFactory&)Factory();
    rFactory.SetDocumentServiceName(C2S("com.sun.star.text.WebDocument"));
	SfxFactoryFilterContainer *pFltContainer = rFactory.GetFilterContainer( FALSE );
	BOOL bInsAllFlt = !pFltContainer || !pFltContainer->GetFilterCount();
	if( bInsAllFlt )
	{
/*------------------------------------
JP 15.07.98: laut MA/ST: nur die absolut notwendigen registrieren

		ULONG nSW4W = SotExchange::RegisterSotFormatName(
									SOT_FORMATSTR_ID_STARWRITERWEB_40 );
		rFactory.RegisterFilter( "StarWriter/Web 4.0 Vorlage/Template",
								"*.vor",
								SFX_FILTER_IMPORT | SFX_FILTER_EXPORT |
								SFX_FILTER_OWN | SFX_FILTER_TEMPLATE |
								SFX_FILTER_ALIEN | SFX_FILTER_TEMPLATEPATH,
								nSW4W,
								"sW/",
								aTypeName,
								ICON_ID_INVALID,
								INetContentTypes::GetContentType(
											CONTENT_TYPE_APP_VND_WRITER_WEB ),
								FILTER_SW4V );

		rFactory.RegisterFilter( "StarWriter 5.0",
								"*.sdw",
								SFX_FILTER_EXPORT | SFX_FILTER_ALIEN |
								SFX_FILTER_TEMPLATE,
								SotExchange::RegisterSotFormatName(
										SOT_FORMATSTR_ID_STARWRITER_50 ),
								"SW/",
								aTypeName,
								ICON_ID_INVALID,
								INetContentTypes::GetContentType(
												CONTENT_TYPE_APP_VND_WRITER ),
								FILTER_SW5 );

		rFactory.RegisterFilter( "StarWriter 4.0",
								"*.sdw",
								SFX_FILTER_EXPORT | SFX_FILTER_ALIEN |
								SFX_FILTER_TEMPLATE,
								SotExchange::RegisterSotFormatName(
										SOT_FORMATSTR_ID_STARWRITER_40 ),
								"SW/",
								aTypeName,
								ICON_ID_INVALID,
								INetContentTypes::GetContentType(
												CONTENT_TYPE_APP_VND_WRITER ),
								FILTER_SW4 );

		rFactory.RegisterFilter( "StarWriter 3.0",
								"*.sdw",
								SFX_FILTER_EXPORT | SFX_FILTER_ALIEN |
								SFX_FILTER_TEMPLATE,
								SotExchange::RegisterSotFormatName(
										SOT_FORMATSTR_ID_STARWRITER_30 ),
								"SW/",
								aTypeName,
								ICON_ID_INVALID,
								INetContentTypes::GetContentType(
												CONTENT_TYPE_APP_VND_WRITER ),
								FILTER_SW3 );

#ifndef MAC
		rFactory.RegisterFilter( "Text MAC (StarWriter/Web)",
								"*.txt",
								SFX_FILTER_IMPORT | SFX_FILTER_EXPORT | SFX_FILTER_ALIEN,
								0,
								"TEXT",
								aTypeName,
								ICON_ID_INVALID,
								"text/plain",
								sTextMac );
#endif
#ifndef UNX
		rFactory.RegisterFilter( "Text Unix (StarWriter/Web)",
								"*.txt",
								SFX_FILTER_IMPORT | SFX_FILTER_EXPORT | SFX_FILTER_ALIEN,
								0,
								"TEXT",
								aTypeName,
								ICON_ID_INVALID,
								"text/plain",
								sTextUnx );
#endif

#ifndef PM2
		rFactory.RegisterFilter( "Text DOS (StarWriter/Web)",
								"*.txt",
								SFX_FILTER_IMPORT | SFX_FILTER_EXPORT | SFX_FILTER_ALIEN,
								0,
								"TEXT",
								aTypeName,
								ICON_ID_INVALID,
								"text/plain",
								sTextDos);
#endif
----------------------------------------------------------*/
	}

	rFactory.GetFilterContainer()->SetDetectFilter( &SwDLL::DetectFilter );
/*
	String sSwCopyRight(ByteString("SW/"), RTL_TEXTENCODING_MS_1252);
	rFactory.RegisterFilter( C2S("StarWriter/Web 5.0 Vorlage/Template"),
							C2S("*.vor"),
							SFX_FILTER_IMPORT | SFX_FILTER_EXPORT |
							SFX_FILTER_OWN | SFX_FILTER_TEMPLATE |
							SFX_FILTER_TEMPLATEPATH,
							SOT_FORMATSTR_ID_STARWRITERWEB_50,
							sSwCopyRight,
							aTypeName,
							ICON_ID_INVALID,
							INetContentTypes::GetContentType(
											CONTENT_TYPE_APP_VND_WRITER_WEB ),
							C2S(FILTER_SW5V ));

#if defined W40 || defined UNX || defined PM2
// Windows 95, OS2 kann htm & html
// Unix auch
	rFactory.RegisterFilter(C2S("HTML"),
							C2S("*.html;*.htm"),
							SFX_FILTER_IMPORT | SFX_FILTER_EXPORT |
							SFX_FILTER_ASYNC,
							0,
							C2S("TEXT"),
							aTypeName,
							ICON_ID_INVALID,
							C2S("text/html"),
							C2S(sHTML) );
#else
	rFactory.RegisterFilter( C2S("HTML"),
							C2S("*.htm"),
							SFX_FILTER_IMPORT | SFX_FILTER_EXPORT |
							SFX_FILTER_ASYNC,
							0,
							C2S("TEXT"),
							aTypeName,
							ICON_ID_INVALID,
							C2S("text/html"),
							C2S(sHTML) );
#endif

	// Die StarWriter-Filter


	rFactory.RegisterFilter(C2S("Text (StarWriter/Web)"),
							C2S("*.txt"),
							SFX_FILTER_IMPORT | SFX_FILTER_EXPORT | SFX_FILTER_ALIEN,
							0,
							C2S("TEXT"),
							aTypeName,
							ICON_ID_INVALID,
							C2S("text/plain"),
							C2S(FILTER_ANSI) );

#if !defined(WIN) && !defined(WNT)
	rFactory.RegisterFilter(C2S("Text WIN (StarWriter/Web)"),
							C2S("*.txt"),
							SFX_FILTER_IMPORT | SFX_FILTER_EXPORT | SFX_FILTER_ALIEN,
							0,
							C2S("TEXT"),
							aTypeName,
							ICON_ID_INVALID,
							C2S("text/plain"),
							C2S(sTextWin) );
#endif
*/
}

//-------------------------------------------------------------------------
SFX_IMPL_OBJECTFACTORY_MOD(SwGlobalDocShell, 										  \
	 	SFXOBJECTSHELL_STD_NORMAL|SFXOBJECTSHELL_HASMENU, swriter/GlobalDocument, \
		SvGlobalName(SO3_SWGLOB_CLASSID),								\
		Sw,																			  \
		DLL_NAME)
{
	// MIB: In der 364 gab es Unterschiede zur Install.ini. Der
	// Filter-Name war hier "StarWriter 4.0 Global Document" und
	// in der install.ini "StarWriter 4.0/GlobalDocument". Mac und
	// OS/2-Name waren in der install.ini voellig falsch.
	// Wir nehmen jetzt den Filter-Namen der install.ini.
	const String aTypeName( C2S("StarWriter 5.0/GlobalDocument") );
	String sEmpty;

	SfxObjectFactory& rFactory = (SfxObjectFactory&)Factory();
    rFactory.SetDocumentServiceName(C2S("com.sun.star.text.GlobalDocument"));
	SfxFactoryFilterContainer *pFltContainer = rFactory.GetFilterContainer( FALSE );
	BOOL bInsAllFlt = !pFltContainer || !pFltContainer->GetFilterCount();
	if( bInsAllFlt )
	{
/*------------------------------------
JP 15.07.98: laut MA/ST: nur die absolut notwendigen registrieren

		ULONG nSW4G = SotExchange::RegisterSotFormatName(
									SOT_FORMATSTR_ID_STARWRITERGLOB_40 );

		rFactory.RegisterFilter( "StarWriter 4.0/GlobalDocument",
								"*.sgl",
								SFX_FILTER_IMPORT | SFX_FILTER_EXPORT |
								SFX_FILTER_ALIEN | SFX_FILTER_OWN |
								SFX_FILTER_TEMPLATE,
								nSW4G,
								"SWgl",
								aTypeName,
								ICON_ID_INVALID,
								INetContentTypes::GetContentType(
										CONTENT_TYPE_APP_VND_WRITER_GLOBAL ),
								FILTER_SW4 );

		// Alle folgenden Filter sind nur Export-Filter

		rFactory.RegisterFilter( "StarWriter 5.0",
								"*.sdw",
								SFX_FILTER_EXPORT | SFX_FILTER_ALIEN |
								SFX_FILTER_TEMPLATE,
								SotExchange::RegisterSotFormatName(
											SOT_FORMATSTR_ID_STARWRITER_50 ),
								"SW/",
								aTypeName,
								ICON_ID_INVALID,
								INetContentTypes::GetContentType(
												CONTENT_TYPE_APP_VND_WRITER ),
								FILTER_SW5 );

		rFactory.RegisterFilter( "StarWriter 4.0",
								"*.sdw",
								SFX_FILTER_EXPORT | SFX_FILTER_ALIEN |
								SFX_FILTER_TEMPLATE,
								SotExchange::RegisterSotFormatName(
											SOT_FORMATSTR_ID_STARWRITER_40 ),
								"SW/",
								aTypeName,
								ICON_ID_INVALID,
								INetContentTypes::GetContentType(
												CONTENT_TYPE_APP_VND_WRITER ),
								FILTER_SW4 );

		rFactory.RegisterFilter( "StarWriter 3.0",
								"*.sdw",
								SFX_FILTER_EXPORT | SFX_FILTER_ALIEN |
								SFX_FILTER_TEMPLATE,
								SotExchange::RegisterSotFormatName(
											SOT_FORMATSTR_ID_STARWRITER_30 ),
								"SW/",
								aTypeName,
								ICON_ID_INVALID,
								INetContentTypes::GetContentType(
												CONTENT_TYPE_APP_VND_WRITER ),
								FILTER_SW3 );

----------------------------------------------------------*/
	}


	rFactory.GetFilterContainer()->SetDetectFilter( &SwDLL::GlobDetectFilter );
/*
	rFactory.RegisterFilter( aTypeName,
							C2S("*.sgl"),
							SFX_FILTER_IMPORT | SFX_FILTER_EXPORT |
							SFX_FILTER_OWN | SFX_FILTER_TEMPLATE,
							SOT_FORMATSTR_ID_STARWRITERGLOB_50,
							C2S("SWgl"),
							aTypeName,
							ICON_ID_INVALID,
							INetContentTypes::GetContentType(
										CONTENT_TYPE_APP_VND_WRITER_GLOBAL ),
							C2S(FILTER_SW5) );
*/
}

//-------------------------------------------------------------------------

void 	SwDLL::LibInit()
{
	// in most cases you must initialize your document-factory here
    SvtModuleOptions aOpt;
    SfxObjectFactory* pWriterFactory = NULL;
    SfxObjectFactory* pGlobalFactory = NULL;
    if ( aOpt.IsWriter() )
    {
        SwDocShell::RegisterFactory(    SDT_SW_DOCFACTPRIO      );
        SwGlobalDocShell::RegisterFactory(SDT_SW_DOCFACTPRIO + 2);
        pWriterFactory = &SwDocShell::Factory();
        pGlobalFactory = &SwGlobalDocShell::Factory();
    }

    // WebWriter alway needed because it is used for the help viewer
	SwWebDocShell::RegisterFactory(	SDT_SW_DOCFACTPRIO + 1	);

	// create a dummy-module for Object-Factory-Pointer
    SW_MOD() = (SwModule*)new SwModuleDummy( 0, TRUE, &SwWebDocShell::Factory(), pWriterFactory, pGlobalFactory );
    SwModule* pMod = SW_MOD();
}

//-------------------------------------------------------------------------
void 	SwDLL::LibExit()
{
		// Innerhalb von FreeLibSw wird Exit() gerufen
	FreeLibSw();

	// destroy the dummy-module with Object-Factory-Pointer
	DELETEZ( *(SwModuleDummy**) GetAppData(SHL_WRITER) );

}

//-------------------------------------------------------------------------

SfxModule* __EXPORT SwModuleDummy::Load()
{
	return (LoadLibSw() ? SW_MOD() : NULL);
}
