#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.5 $
#
#   last change: $Author: kso $ $Date: 2001/06/19 09:20:01 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************

PRJ=..

PRJNAME=ucbhelper
TARGET=unotypes
AUTOSEG=true

# --- Settings -----------------------------------------------------

.INCLUDE :  svpre.mk
.INCLUDE :  settings.mk
.INCLUDE :  sv.mk

UNOUCRDEP=$(SOLARBINDIR)$/applicat.rdb
UNOUCRRDB=$(SOLARBINDIR)$/applicat.rdb
UNOUCROUT=$(OUT)$/inc

UNOTYPES=\
	com.sun.star.beans.PropertyAttribute\
	com.sun.star.beans.PropertySetInfoChange\
	com.sun.star.beans.PropertyValue\
	com.sun.star.beans.XPropertiesChangeNotifier\
	com.sun.star.beans.XPropertyAccess\
	com.sun.star.beans.XPropertyContainer\
	com.sun.star.beans.XPropertySetInfo\
	com.sun.star.beans.XPropertySetInfoChangeNotifier\
	com.sun.star.connection.XConnection\
	com.sun.star.connection.XConnectionBroadcaster\
	com.sun.star.container.XChild\
	com.sun.star.container.XHierarchicalNameAccess\
	com.sun.star.container.XNamed\
	com.sun.star.io.XActiveDataSink\
	com.sun.star.io.XStreamListener\
	com.sun.star.lang.XMultiServiceFactory\
	com.sun.star.lang.XSingleServiceFactory\
	com.sun.star.lang.XServiceInfo\
	com.sun.star.lang.XTypeProvider\
	com.sun.star.registry.XRegistryKey\
	com.sun.star.script.XTypeConverter\
	com.sun.star.sdbc.ColumnValue\
	com.sun.star.sdbc.DataType\
	com.sun.star.sdbc.XCloseable\
	com.sun.star.sdbc.XColumnLocate\
	com.sun.star.sdbc.XResultSetMetaData\
	com.sun.star.sdbc.XResultSetMetaDataSupplier\
	com.sun.star.sdbc.XRow\
        com.sun.star.task.XInteractionAbort\
        com.sun.star.task.XInteractionApprove\
        com.sun.star.task.XInteractionDisapprove\
        com.sun.star.task.XInteractionHandler\
        com.sun.star.task.XInteractionRequest\
        com.sun.star.task.XInteractionRetry\
        com.sun.star.ucb.AuthenticationRequest\
        com.sun.star.ucb.CommandFailedException\
	com.sun.star.ucb.CommandInfoChange\
	com.sun.star.ucb.ContentAction\
	com.sun.star.ucb.ContentCreationError\
	com.sun.star.ucb.ContentCreationException\
	com.sun.star.ucb.GlobalTransferCommandArgument\
	com.sun.star.ucb.InsertCommandArgument\
        com.sun.star.ucb.InteractiveAugmentedIOException\
        com.sun.star.ucb.InteractiveIOException\
	com.sun.star.ucb.ListActionType\
	com.sun.star.ucb.NameClash\
        com.sun.star.ucb.NameClashResolveRequest\
	com.sun.star.ucb.OpenCommandArgument2\
	com.sun.star.ucb.OpenMode\
	com.sun.star.ucb.ResultSetException\
	com.sun.star.ucb.WelcomeDynamicResultSetStruct\
	com.sun.star.ucb.XCachedDynamicResultSetStubFactory\
	com.sun.star.ucb.XCommandEnvironment\
	com.sun.star.ucb.XCommandInfo\
	com.sun.star.ucb.XCommandInfoChangeNotifier\
	com.sun.star.ucb.XCommandProcessor\
	com.sun.star.ucb.XContentAccess\
	com.sun.star.ucb.XContentCreator\
	com.sun.star.ucb.XContentIdentifierFactory\
	com.sun.star.ucb.XContentProvider\
	com.sun.star.ucb.XContentProviderFactory\
	com.sun.star.ucb.XContentProviderManager\
	com.sun.star.ucb.XDynamicResultSet\
	com.sun.star.ucb.XFileIdentifierConverter\
        com.sun.star.ucb.XInteractionReplaceExistingData\
        com.sun.star.ucb.XInteractionSupplyAuthentication\
        com.sun.star.ucb.XInteractionSupplyName\
	com.sun.star.ucb.XParameterizedContentProvider\
	com.sun.star.ucb.XPropertySetRegistryFactory\
	com.sun.star.ucb.XRemoteContentProviderDoneListener\
	com.sun.star.ucb.XSourceInitialization\
	com.sun.star.uno.XWeak

# --- Targets ------------------------------------------------------

.INCLUDE :  target.mk
