# Settings for Solaris using Sun Workshop compiler

OS=SOLARIS
PLATFORM=solsparc
PS=/
CC=CC
LINK=CC
LIB=CC
ECHO=@echo
MKDIR=mkdir -p
CAT=cat
OBJ_EXT=o
SHAREDLIB_EXT=so
SHAREDLIB_PRE=lib
DEL=rm -f
COPY=cp
URLPREFIX=file://

# Include UDK version numbers
include $(PRJ)$(PS)include$(PS)udkversion.mk

SALLIB=-lsal
CPPULIB=-lcppu
CPPUHELPERLIB=-lcppuhelper$(UDK_MAJOR)C52

EMPTYSTRING=
PATH_SEPARATOR=:

CC_FLAGS=-c -KPIC
CC_INCLUDES=-I. -I$(PS)usr$(PS)include -I$(OUT)$(PS)inc$(PS)examples -I$(PRJ)$(PS)include
CC_DEFINES=-DUNX -DSOLARIS -DSPARC
CC_OUTPUT_SWITCH=-o 

LIBRARY_LINK_FLAGS=-w -PIC -temp=$(PS)tmp -R $(PS)usr$(PS)lib -G -lthread -instances=static 
LINK_LIBS=-L$(OUT)$(PS)lib -L$(PRJ)$(PS)lib -L$(PS)usr$(PS)lib -L$(PS)usr$(PS)local$(PS)lib -L$(PS)lib


