#*************************************************************************
#*
#*    $Workfile:   makefile  $
#*
#*    Ersterstellung     JSC 16.06.98
#*    Letzte Aenderung   $Author: kr $   $Date: 2001/05/04 07:05:18 $
#*    $Revision: 1.1 $
#*
#*    $Logfile:   T:/tools/workben/makefile.__v  $
#*
#*    Copyright (c) 1990 - 1997, STAR DIVISION
#*
#*************************************************************************

PRJ=..$/..

PRJNAME=testtools
TARGET=testcp
EXETARGET=testprg
TARGETTYPE=CUI
NO_BSYMBOLIC=TRUE
#LIBTARGET=NO

ENABLE_EXCEPTIONS=TRUE

# --- Settings -----------------------------------------------------
.INCLUDE :  svpre.mk
.INCLUDE :  settings.mk
.INCLUDE :  sv.mk

UNOUCRDEP=$(SOLARBINDIR)$/applicat.rdb 
UNOUCRRDB=$(SOLARBINDIR)$/applicat.rdb

# output directory (one dir for each project)
UNOUCROUT=$(OUT)$/inc

# adding to inludepath
INCPRE+=$(UNOUCROUT)

#UNOTYPES=\
#		 	com.sun.star.uno.TypeClass \
#			com.sun.star.beans.XPropertySet 	\
#			com.sun.star.beans.XIntrospection 	\
#		 	com.sun.star.lang.XMultiServiceFactory \
#		 	com.sun.star.lang.XSingleServiceFactory \
#		 	com.sun.star.lang.XComponent \
#		 	com.sun.star.test.XSimpleTest \
#			com.sun.star.registry.XImplementationRegistration

# --- Files --------------------------------------------------------
CDEFS += -DDLL_VERSION=\"$(UPD)$(DLLPOSTFIX)\"


CXXFILES= \
			testmain.cxx	\
			testimpl.cxx	\
			testcp.cxx


APP1TARGET= $(EXETARGET)
APP1OBJS=   \
			$(OBJ)$/testmain.obj	\
			$(SLO)$/testimpl.obj	\
			$(SLO)$/testcp.obj

APP1STDLIBS=\
			$(SALLIB) \
            $(VOSLIB) \
			$(CPPULIB)	\
			$(CPPUHELPERLIB)

.IF "$(GUI)"=="WNT" || "$(COM)"=="GCC"
APP1STDLIBS+= \
			$(CPPULIB)
.ENDIF

.IF "$(GUI)"=="WNT"
APP1STDLIBS+= \
			$(LIBCIMT) \
			$(LIBCMT)
.ENDIF


SLOFILES =	\
			$(SLO)$/testimpl.obj	\
			$(SLO)$/testcp.obj

SHL1TARGET= $(TARGET)

SHL1STDLIBS= \
			$(SALLIB) \
            $(VOSLIB) \
			$(CPPULIB)	\
			$(CPPUHELPERLIB)


SHL1DEPN=
SHL1IMPLIB=		i$(TARGET)
SHL1LIBS=		$(SLB)$/$(TARGET).lib
SHL1DEF=		$(MISC)$/$(SHL1TARGET).def

DEF1NAME=		$(SHL1TARGET)
DEF1EXPORTFILE=	exports.dxp



.INCLUDE :  target.mk

