/*************************************************************************
#*
#*    $Workfile:   testsmgr.hxx  $
#*
#*    Ersterstellung    AB 17.04.2000
#*    Letzte Aenderung  $Author: kr $ $Date: 2001/05/04 07:05:18 $
#*
#*    $Logfile: $
#*
#*    Copyright (c) 2000, Star Office Entwicklungs GmbH
#*
#*************************************************************************

      Source Code Control System - Header

      $Header: /cvs/oo/udk/testtools/source/testframework/testsmgr.hxx,v 1.1 2001/05/04 07:05:18 kr Exp $

*************************************************************************/


#include <com/sun/star/lang/XMultiServiceFactory.hpp>

#ifndef _CPPUHELPER_WEAK_HXX_
#include <cppuhelper/weak.hxx>
#endif
#include <cppuhelper/implbase1.hxx>

using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::lang;
using namespace ::cppu;
using namespace rtl;



// TODO
//namespace testtools
//{

typedef WeakImplHelper1< XMultiServiceFactory > XMultiServiceFactoryHelper;


class TestMultiServiceFactory : public XMultiServiceFactoryHelper
{
	Reference< XMultiServiceFactory > mxSMgr;

public:

	TestMultiServiceFactory( Reference< XMultiServiceFactory > xSMgr )
		: mxSMgr( xSMgr ) {}

    // Methods
    Reference< XInterface > SAL_CALL createInstance( const OUString& aServiceSpecifier ) 
		throw(Exception, RuntimeException);
    Reference< XInterface > SAL_CALL createInstanceWithArguments
		( const OUString& ServiceSpecifier, const Sequence< Any >& Arguments ) 
			throw(Exception, RuntimeException);
    Sequence< OUString > SAL_CALL getAvailableServiceNames(  ) 
		throw(RuntimeException);
};




/*************************************************************************

      Source Code Control System - Update

      $Log: testsmgr.hxx,v $
      Revision 1.1  2001/05/04 07:05:18  kr
      moved from grande to openoffice

      Revision 1.1.1.1  2000/04/18 11:54:39  ab
      Neu



*************************************************************************/
